import { createAggregatedClient } from "@smithy/smithy-client";
import { AddTagsToResourceCommand, } from "./commands/AddTagsToResourceCommand";
import { ApplyPendingMaintenanceActionCommand, } from "./commands/ApplyPendingMaintenanceActionCommand";
import { BatchStartRecommendationsCommand, } from "./commands/BatchStartRecommendationsCommand";
import { CancelReplicationTaskAssessmentRunCommand, } from "./commands/CancelReplicationTaskAssessmentRunCommand";
import { CreateDataMigrationCommand, } from "./commands/CreateDataMigrationCommand";
import { CreateDataProviderCommand, } from "./commands/CreateDataProviderCommand";
import { CreateEndpointCommand, } from "./commands/CreateEndpointCommand";
import { CreateEventSubscriptionCommand, } from "./commands/CreateEventSubscriptionCommand";
import { CreateFleetAdvisorCollectorCommand, } from "./commands/CreateFleetAdvisorCollectorCommand";
import { CreateInstanceProfileCommand, } from "./commands/CreateInstanceProfileCommand";
import { CreateMigrationProjectCommand, } from "./commands/CreateMigrationProjectCommand";
import { CreateReplicationConfigCommand, } from "./commands/CreateReplicationConfigCommand";
import { CreateReplicationInstanceCommand, } from "./commands/CreateReplicationInstanceCommand";
import { CreateReplicationSubnetGroupCommand, } from "./commands/CreateReplicationSubnetGroupCommand";
import { CreateReplicationTaskCommand, } from "./commands/CreateReplicationTaskCommand";
import { DeleteCertificateCommand, } from "./commands/DeleteCertificateCommand";
import { DeleteConnectionCommand, } from "./commands/DeleteConnectionCommand";
import { DeleteDataMigrationCommand, } from "./commands/DeleteDataMigrationCommand";
import { DeleteDataProviderCommand, } from "./commands/DeleteDataProviderCommand";
import { DeleteEndpointCommand, } from "./commands/DeleteEndpointCommand";
import { DeleteEventSubscriptionCommand, } from "./commands/DeleteEventSubscriptionCommand";
import { DeleteFleetAdvisorCollectorCommand, } from "./commands/DeleteFleetAdvisorCollectorCommand";
import { DeleteFleetAdvisorDatabasesCommand, } from "./commands/DeleteFleetAdvisorDatabasesCommand";
import { DeleteInstanceProfileCommand, } from "./commands/DeleteInstanceProfileCommand";
import { DeleteMigrationProjectCommand, } from "./commands/DeleteMigrationProjectCommand";
import { DeleteReplicationConfigCommand, } from "./commands/DeleteReplicationConfigCommand";
import { DeleteReplicationInstanceCommand, } from "./commands/DeleteReplicationInstanceCommand";
import { DeleteReplicationSubnetGroupCommand, } from "./commands/DeleteReplicationSubnetGroupCommand";
import { DeleteReplicationTaskAssessmentRunCommand, } from "./commands/DeleteReplicationTaskAssessmentRunCommand";
import { DeleteReplicationTaskCommand, } from "./commands/DeleteReplicationTaskCommand";
import { DescribeAccountAttributesCommand, } from "./commands/DescribeAccountAttributesCommand";
import { DescribeApplicableIndividualAssessmentsCommand, } from "./commands/DescribeApplicableIndividualAssessmentsCommand";
import { DescribeCertificatesCommand, } from "./commands/DescribeCertificatesCommand";
import { DescribeConnectionsCommand, } from "./commands/DescribeConnectionsCommand";
import { DescribeConversionConfigurationCommand, } from "./commands/DescribeConversionConfigurationCommand";
import { DescribeDataMigrationsCommand, } from "./commands/DescribeDataMigrationsCommand";
import { DescribeDataProvidersCommand, } from "./commands/DescribeDataProvidersCommand";
import { DescribeEndpointsCommand, } from "./commands/DescribeEndpointsCommand";
import { DescribeEndpointSettingsCommand, } from "./commands/DescribeEndpointSettingsCommand";
import { DescribeEndpointTypesCommand, } from "./commands/DescribeEndpointTypesCommand";
import { DescribeEngineVersionsCommand, } from "./commands/DescribeEngineVersionsCommand";
import { DescribeEventCategoriesCommand, } from "./commands/DescribeEventCategoriesCommand";
import { DescribeEventsCommand, } from "./commands/DescribeEventsCommand";
import { DescribeEventSubscriptionsCommand, } from "./commands/DescribeEventSubscriptionsCommand";
import { DescribeExtensionPackAssociationsCommand, } from "./commands/DescribeExtensionPackAssociationsCommand";
import { DescribeFleetAdvisorCollectorsCommand, } from "./commands/DescribeFleetAdvisorCollectorsCommand";
import { DescribeFleetAdvisorDatabasesCommand, } from "./commands/DescribeFleetAdvisorDatabasesCommand";
import { DescribeFleetAdvisorLsaAnalysisCommand, } from "./commands/DescribeFleetAdvisorLsaAnalysisCommand";
import { DescribeFleetAdvisorSchemaObjectSummaryCommand, } from "./commands/DescribeFleetAdvisorSchemaObjectSummaryCommand";
import { DescribeFleetAdvisorSchemasCommand, } from "./commands/DescribeFleetAdvisorSchemasCommand";
import { DescribeInstanceProfilesCommand, } from "./commands/DescribeInstanceProfilesCommand";
import { DescribeMetadataModelAssessmentsCommand, } from "./commands/DescribeMetadataModelAssessmentsCommand";
import { DescribeMetadataModelConversionsCommand, } from "./commands/DescribeMetadataModelConversionsCommand";
import { DescribeMetadataModelExportsAsScriptCommand, } from "./commands/DescribeMetadataModelExportsAsScriptCommand";
import { DescribeMetadataModelExportsToTargetCommand, } from "./commands/DescribeMetadataModelExportsToTargetCommand";
import { DescribeMetadataModelImportsCommand, } from "./commands/DescribeMetadataModelImportsCommand";
import { DescribeMigrationProjectsCommand, } from "./commands/DescribeMigrationProjectsCommand";
import { DescribeOrderableReplicationInstancesCommand, } from "./commands/DescribeOrderableReplicationInstancesCommand";
import { DescribePendingMaintenanceActionsCommand, } from "./commands/DescribePendingMaintenanceActionsCommand";
import { DescribeRecommendationLimitationsCommand, } from "./commands/DescribeRecommendationLimitationsCommand";
import { DescribeRecommendationsCommand, } from "./commands/DescribeRecommendationsCommand";
import { DescribeRefreshSchemasStatusCommand, } from "./commands/DescribeRefreshSchemasStatusCommand";
import { DescribeReplicationConfigsCommand, } from "./commands/DescribeReplicationConfigsCommand";
import { DescribeReplicationInstancesCommand, } from "./commands/DescribeReplicationInstancesCommand";
import { DescribeReplicationInstanceTaskLogsCommand, } from "./commands/DescribeReplicationInstanceTaskLogsCommand";
import { DescribeReplicationsCommand, } from "./commands/DescribeReplicationsCommand";
import { DescribeReplicationSubnetGroupsCommand, } from "./commands/DescribeReplicationSubnetGroupsCommand";
import { DescribeReplicationTableStatisticsCommand, } from "./commands/DescribeReplicationTableStatisticsCommand";
import { DescribeReplicationTaskAssessmentResultsCommand, } from "./commands/DescribeReplicationTaskAssessmentResultsCommand";
import { DescribeReplicationTaskAssessmentRunsCommand, } from "./commands/DescribeReplicationTaskAssessmentRunsCommand";
import { DescribeReplicationTaskIndividualAssessmentsCommand, } from "./commands/DescribeReplicationTaskIndividualAssessmentsCommand";
import { DescribeReplicationTasksCommand, } from "./commands/DescribeReplicationTasksCommand";
import { DescribeSchemasCommand, } from "./commands/DescribeSchemasCommand";
import { DescribeTableStatisticsCommand, } from "./commands/DescribeTableStatisticsCommand";
import { ExportMetadataModelAssessmentCommand, } from "./commands/ExportMetadataModelAssessmentCommand";
import { ImportCertificateCommand, } from "./commands/ImportCertificateCommand";
import { ListTagsForResourceCommand, } from "./commands/ListTagsForResourceCommand";
import { ModifyConversionConfigurationCommand, } from "./commands/ModifyConversionConfigurationCommand";
import { ModifyDataMigrationCommand, } from "./commands/ModifyDataMigrationCommand";
import { ModifyDataProviderCommand, } from "./commands/ModifyDataProviderCommand";
import { ModifyEndpointCommand, } from "./commands/ModifyEndpointCommand";
import { ModifyEventSubscriptionCommand, } from "./commands/ModifyEventSubscriptionCommand";
import { ModifyInstanceProfileCommand, } from "./commands/ModifyInstanceProfileCommand";
import { ModifyMigrationProjectCommand, } from "./commands/ModifyMigrationProjectCommand";
import { ModifyReplicationConfigCommand, } from "./commands/ModifyReplicationConfigCommand";
import { ModifyReplicationInstanceCommand, } from "./commands/ModifyReplicationInstanceCommand";
import { ModifyReplicationSubnetGroupCommand, } from "./commands/ModifyReplicationSubnetGroupCommand";
import { ModifyReplicationTaskCommand, } from "./commands/ModifyReplicationTaskCommand";
import { MoveReplicationTaskCommand, } from "./commands/MoveReplicationTaskCommand";
import { RebootReplicationInstanceCommand, } from "./commands/RebootReplicationInstanceCommand";
import { RefreshSchemasCommand, } from "./commands/RefreshSchemasCommand";
import { ReloadReplicationTablesCommand, } from "./commands/ReloadReplicationTablesCommand";
import { ReloadTablesCommand, } from "./commands/ReloadTablesCommand";
import { RemoveTagsFromResourceCommand, } from "./commands/RemoveTagsFromResourceCommand";
import { RunFleetAdvisorLsaAnalysisCommand, } from "./commands/RunFleetAdvisorLsaAnalysisCommand";
import { StartDataMigrationCommand, } from "./commands/StartDataMigrationCommand";
import { StartExtensionPackAssociationCommand, } from "./commands/StartExtensionPackAssociationCommand";
import { StartMetadataModelAssessmentCommand, } from "./commands/StartMetadataModelAssessmentCommand";
import { StartMetadataModelConversionCommand, } from "./commands/StartMetadataModelConversionCommand";
import { StartMetadataModelExportAsScriptCommand, } from "./commands/StartMetadataModelExportAsScriptCommand";
import { StartMetadataModelExportToTargetCommand, } from "./commands/StartMetadataModelExportToTargetCommand";
import { StartMetadataModelImportCommand, } from "./commands/StartMetadataModelImportCommand";
import { StartRecommendationsCommand, } from "./commands/StartRecommendationsCommand";
import { StartReplicationCommand, } from "./commands/StartReplicationCommand";
import { StartReplicationTaskAssessmentCommand, } from "./commands/StartReplicationTaskAssessmentCommand";
import { StartReplicationTaskAssessmentRunCommand, } from "./commands/StartReplicationTaskAssessmentRunCommand";
import { StartReplicationTaskCommand, } from "./commands/StartReplicationTaskCommand";
import { StopDataMigrationCommand, } from "./commands/StopDataMigrationCommand";
import { StopReplicationCommand, } from "./commands/StopReplicationCommand";
import { StopReplicationTaskCommand, } from "./commands/StopReplicationTaskCommand";
import { TestConnectionCommand, } from "./commands/TestConnectionCommand";
import { UpdateSubscriptionsToEventBridgeCommand, } from "./commands/UpdateSubscriptionsToEventBridgeCommand";
import { DatabaseMigrationServiceClient } from "./DatabaseMigrationServiceClient";
const commands = {
    AddTagsToResourceCommand,
    ApplyPendingMaintenanceActionCommand,
    BatchStartRecommendationsCommand,
    CancelReplicationTaskAssessmentRunCommand,
    CreateDataMigrationCommand,
    CreateDataProviderCommand,
    CreateEndpointCommand,
    CreateEventSubscriptionCommand,
    CreateFleetAdvisorCollectorCommand,
    CreateInstanceProfileCommand,
    CreateMigrationProjectCommand,
    CreateReplicationConfigCommand,
    CreateReplicationInstanceCommand,
    CreateReplicationSubnetGroupCommand,
    CreateReplicationTaskCommand,
    DeleteCertificateCommand,
    DeleteConnectionCommand,
    DeleteDataMigrationCommand,
    DeleteDataProviderCommand,
    DeleteEndpointCommand,
    DeleteEventSubscriptionCommand,
    DeleteFleetAdvisorCollectorCommand,
    DeleteFleetAdvisorDatabasesCommand,
    DeleteInstanceProfileCommand,
    DeleteMigrationProjectCommand,
    DeleteReplicationConfigCommand,
    DeleteReplicationInstanceCommand,
    DeleteReplicationSubnetGroupCommand,
    DeleteReplicationTaskCommand,
    DeleteReplicationTaskAssessmentRunCommand,
    DescribeAccountAttributesCommand,
    DescribeApplicableIndividualAssessmentsCommand,
    DescribeCertificatesCommand,
    DescribeConnectionsCommand,
    DescribeConversionConfigurationCommand,
    DescribeDataMigrationsCommand,
    DescribeDataProvidersCommand,
    DescribeEndpointsCommand,
    DescribeEndpointSettingsCommand,
    DescribeEndpointTypesCommand,
    DescribeEngineVersionsCommand,
    DescribeEventCategoriesCommand,
    DescribeEventsCommand,
    DescribeEventSubscriptionsCommand,
    DescribeExtensionPackAssociationsCommand,
    DescribeFleetAdvisorCollectorsCommand,
    DescribeFleetAdvisorDatabasesCommand,
    DescribeFleetAdvisorLsaAnalysisCommand,
    DescribeFleetAdvisorSchemaObjectSummaryCommand,
    DescribeFleetAdvisorSchemasCommand,
    DescribeInstanceProfilesCommand,
    DescribeMetadataModelAssessmentsCommand,
    DescribeMetadataModelConversionsCommand,
    DescribeMetadataModelExportsAsScriptCommand,
    DescribeMetadataModelExportsToTargetCommand,
    DescribeMetadataModelImportsCommand,
    DescribeMigrationProjectsCommand,
    DescribeOrderableReplicationInstancesCommand,
    DescribePendingMaintenanceActionsCommand,
    DescribeRecommendationLimitationsCommand,
    DescribeRecommendationsCommand,
    DescribeRefreshSchemasStatusCommand,
    DescribeReplicationConfigsCommand,
    DescribeReplicationInstancesCommand,
    DescribeReplicationInstanceTaskLogsCommand,
    DescribeReplicationsCommand,
    DescribeReplicationSubnetGroupsCommand,
    DescribeReplicationTableStatisticsCommand,
    DescribeReplicationTaskAssessmentResultsCommand,
    DescribeReplicationTaskAssessmentRunsCommand,
    DescribeReplicationTaskIndividualAssessmentsCommand,
    DescribeReplicationTasksCommand,
    DescribeSchemasCommand,
    DescribeTableStatisticsCommand,
    ExportMetadataModelAssessmentCommand,
    ImportCertificateCommand,
    ListTagsForResourceCommand,
    ModifyConversionConfigurationCommand,
    ModifyDataMigrationCommand,
    ModifyDataProviderCommand,
    ModifyEndpointCommand,
    ModifyEventSubscriptionCommand,
    ModifyInstanceProfileCommand,
    ModifyMigrationProjectCommand,
    ModifyReplicationConfigCommand,
    ModifyReplicationInstanceCommand,
    ModifyReplicationSubnetGroupCommand,
    ModifyReplicationTaskCommand,
    MoveReplicationTaskCommand,
    RebootReplicationInstanceCommand,
    RefreshSchemasCommand,
    ReloadReplicationTablesCommand,
    ReloadTablesCommand,
    RemoveTagsFromResourceCommand,
    RunFleetAdvisorLsaAnalysisCommand,
    StartDataMigrationCommand,
    StartExtensionPackAssociationCommand,
    StartMetadataModelAssessmentCommand,
    StartMetadataModelConversionCommand,
    StartMetadataModelExportAsScriptCommand,
    StartMetadataModelExportToTargetCommand,
    StartMetadataModelImportCommand,
    StartRecommendationsCommand,
    StartReplicationCommand,
    StartReplicationTaskCommand,
    StartReplicationTaskAssessmentCommand,
    StartReplicationTaskAssessmentRunCommand,
    StopDataMigrationCommand,
    StopReplicationCommand,
    StopReplicationTaskCommand,
    TestConnectionCommand,
    UpdateSubscriptionsToEventBridgeCommand,
};
export class DatabaseMigrationService extends DatabaseMigrationServiceClient {
}
createAggregatedClient(commands, DatabaseMigrationService);
