import { SENSITIVE_STRING } from "@smithy/smithy-client";
import { DatabaseMigrationServiceServiceException as __BaseException } from "./DatabaseMigrationServiceServiceException";
export class AccessDeniedFault extends __BaseException {
    name = "AccessDeniedFault";
    $fault = "client";
    constructor(opts) {
        super({
            name: "AccessDeniedFault",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, AccessDeniedFault.prototype);
    }
}
export class InvalidResourceStateFault extends __BaseException {
    name = "InvalidResourceStateFault";
    $fault = "client";
    constructor(opts) {
        super({
            name: "InvalidResourceStateFault",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, InvalidResourceStateFault.prototype);
    }
}
export class ResourceNotFoundFault extends __BaseException {
    name = "ResourceNotFoundFault";
    $fault = "client";
    constructor(opts) {
        super({
            name: "ResourceNotFoundFault",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, ResourceNotFoundFault.prototype);
    }
}
export const MigrationTypeValue = {
    CDC: "cdc",
    FULL_LOAD: "full-load",
    FULL_LOAD_AND_CDC: "full-load-and-cdc",
};
export const TablePreparationMode = {
    DO_NOTHING: "do-nothing",
    DROP_TABLES_ON_TARGET: "drop-tables-on-target",
    TRUNCATE: "truncate",
};
export class FailedDependencyFault extends __BaseException {
    name = "FailedDependencyFault";
    $fault = "client";
    constructor(opts) {
        super({
            name: "FailedDependencyFault",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, FailedDependencyFault.prototype);
    }
}
export class InvalidOperationFault extends __BaseException {
    name = "InvalidOperationFault";
    $fault = "client";
    constructor(opts) {
        super({
            name: "InvalidOperationFault",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, InvalidOperationFault.prototype);
    }
}
export class ResourceAlreadyExistsFault extends __BaseException {
    name = "ResourceAlreadyExistsFault";
    $fault = "client";
    resourceArn;
    constructor(opts) {
        super({
            name: "ResourceAlreadyExistsFault",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, ResourceAlreadyExistsFault.prototype);
        this.resourceArn = opts.resourceArn;
    }
}
export class ResourceQuotaExceededFault extends __BaseException {
    name = "ResourceQuotaExceededFault";
    $fault = "client";
    constructor(opts) {
        super({
            name: "ResourceQuotaExceededFault",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, ResourceQuotaExceededFault.prototype);
    }
}
export const DmsSslModeValue = {
    NONE: "none",
    REQUIRE: "require",
    VERIFY_CA: "verify-ca",
    VERIFY_FULL: "verify-full",
};
export const AuthMechanismValue = {
    DEFAULT: "default",
    MONGODB_CR: "mongodb_cr",
    SCRAM_SHA_1: "scram_sha_1",
};
export const AuthTypeValue = {
    NO: "no",
    PASSWORD: "password",
};
export var DataProviderSettings;
(function (DataProviderSettings) {
    DataProviderSettings.visit = (value, visitor) => {
        if (value.RedshiftSettings !== undefined)
            return visitor.RedshiftSettings(value.RedshiftSettings);
        if (value.PostgreSqlSettings !== undefined)
            return visitor.PostgreSqlSettings(value.PostgreSqlSettings);
        if (value.MySqlSettings !== undefined)
            return visitor.MySqlSettings(value.MySqlSettings);
        if (value.OracleSettings !== undefined)
            return visitor.OracleSettings(value.OracleSettings);
        if (value.MicrosoftSqlServerSettings !== undefined)
            return visitor.MicrosoftSqlServerSettings(value.MicrosoftSqlServerSettings);
        if (value.DocDbSettings !== undefined)
            return visitor.DocDbSettings(value.DocDbSettings);
        if (value.MariaDbSettings !== undefined)
            return visitor.MariaDbSettings(value.MariaDbSettings);
        if (value.MongoDbSettings !== undefined)
            return visitor.MongoDbSettings(value.MongoDbSettings);
        return visitor._(value.$unknown[0], value.$unknown[1]);
    };
})(DataProviderSettings || (DataProviderSettings = {}));
export const NestingLevelValue = {
    NONE: "none",
    ONE: "one",
};
export const ReplicationEndpointTypeValue = {
    SOURCE: "source",
    TARGET: "target",
};
export const TargetDbType = {
    MULTIPLE_DATABASES: "multiple-databases",
    SPECIFIC_DATABASE: "specific-database",
};
export const MessageFormatValue = {
    JSON: "json",
    JSON_UNFORMATTED: "json-unformatted",
};
export const KafkaSaslMechanism = {
    PLAIN: "plain",
    SCRAM_SHA_512: "scram-sha-512",
};
export const KafkaSecurityProtocol = {
    PLAINTEXT: "plaintext",
    SASL_SSL: "sasl-ssl",
    SSL_AUTHENTICATION: "ssl-authentication",
    SSL_ENCRYPTION: "ssl-encryption",
};
export const KafkaSslEndpointIdentificationAlgorithm = {
    HTTPS: "https",
    NONE: "none",
};
export const SqlServerAuthenticationMethod = {
    Kerberos: "kerberos",
    Password: "password",
};
export const SafeguardPolicy = {
    EXCLUSIVE_AUTOMATIC_TRUNCATION: "exclusive-automatic-truncation",
    RELY_ON_SQL_SERVER_REPLICATION_AGENT: "rely-on-sql-server-replication-agent",
    SHARED_AUTOMATIC_TRUNCATION: "shared-automatic-truncation",
};
export const TlogAccessMode = {
    BackupOnly: "BackupOnly",
    PreferBackup: "PreferBackup",
    PreferTlog: "PreferTlog",
    TlogOnly: "TlogOnly",
};
export const OracleAuthenticationMethod = {
    Kerberos: "kerberos",
    Password: "password",
};
export const CharLengthSemantics = {
    BYTE: "byte",
    CHAR: "char",
    DEFAULT: "default",
};
export const DatabaseMode = {
    BABELFISH: "babelfish",
    DEFAULT: "default",
};
export const LongVarcharMappingType = {
    CLOB: "clob",
    NCLOB: "nclob",
    WSTRING: "wstring",
};
export const PluginNameValue = {
    NO_PREFERENCE: "no-preference",
    PGLOGICAL: "pglogical",
    TEST_DECODING: "test-decoding",
};
export const RedisAuthTypeValue = {
    AUTH_ROLE: "auth-role",
    AUTH_TOKEN: "auth-token",
    NONE: "none",
};
export const SslSecurityProtocolValue = {
    PLAINTEXT: "plaintext",
    SSL_ENCRYPTION: "ssl-encryption",
};
export const EncryptionModeValue = {
    SSE_KMS: "sse-kms",
    SSE_S3: "sse-s3",
};
export const CannedAclForObjectsValue = {
    AUTHENTICATED_READ: "authenticated-read",
    AWS_EXEC_READ: "aws-exec-read",
    BUCKET_OWNER_FULL_CONTROL: "bucket-owner-full-control",
    BUCKET_OWNER_READ: "bucket-owner-read",
    NONE: "none",
    PRIVATE: "private",
    PUBLIC_READ: "public-read",
    PUBLIC_READ_WRITE: "public-read-write",
};
export const CompressionTypeValue = {
    GZIP: "gzip",
    NONE: "none",
};
export const DataFormatValue = {
    CSV: "csv",
    PARQUET: "parquet",
};
export const DatePartitionDelimiterValue = {
    DASH: "DASH",
    NONE: "NONE",
    SLASH: "SLASH",
    UNDERSCORE: "UNDERSCORE",
};
export const DatePartitionSequenceValue = {
    DDMMYYYY: "DDMMYYYY",
    MMYYYYDD: "MMYYYYDD",
    YYYYMM: "YYYYMM",
    YYYYMMDD: "YYYYMMDD",
    YYYYMMDDHH: "YYYYMMDDHH",
};
export const EncodingTypeValue = {
    PLAIN: "plain",
    PLAIN_DICTIONARY: "plain-dictionary",
    RLE_DICTIONARY: "rle-dictionary",
};
export const ParquetVersionValue = {
    PARQUET_1_0: "parquet-1-0",
    PARQUET_2_0: "parquet-2-0",
};
export class KMSKeyNotAccessibleFault extends __BaseException {
    name = "KMSKeyNotAccessibleFault";
    $fault = "client";
    constructor(opts) {
        super({
            name: "KMSKeyNotAccessibleFault",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, KMSKeyNotAccessibleFault.prototype);
    }
}
export class S3AccessDeniedFault extends __BaseException {
    name = "S3AccessDeniedFault";
    $fault = "client";
    constructor(opts) {
        super({
            name: "S3AccessDeniedFault",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, S3AccessDeniedFault.prototype);
    }
}
export class KMSAccessDeniedFault extends __BaseException {
    name = "KMSAccessDeniedFault";
    $fault = "client";
    constructor(opts) {
        super({
            name: "KMSAccessDeniedFault",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, KMSAccessDeniedFault.prototype);
    }
}
export class KMSDisabledFault extends __BaseException {
    name = "KMSDisabledFault";
    $fault = "client";
    constructor(opts) {
        super({
            name: "KMSDisabledFault",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, KMSDisabledFault.prototype);
    }
}
export class KMSInvalidStateFault extends __BaseException {
    name = "KMSInvalidStateFault";
    $fault = "client";
    constructor(opts) {
        super({
            name: "KMSInvalidStateFault",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, KMSInvalidStateFault.prototype);
    }
}
export class KMSNotFoundFault extends __BaseException {
    name = "KMSNotFoundFault";
    $fault = "client";
    constructor(opts) {
        super({
            name: "KMSNotFoundFault",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, KMSNotFoundFault.prototype);
    }
}
export class KMSThrottlingFault extends __BaseException {
    name = "KMSThrottlingFault";
    $fault = "client";
    constructor(opts) {
        super({
            name: "KMSThrottlingFault",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, KMSThrottlingFault.prototype);
    }
}
export class SNSInvalidTopicFault extends __BaseException {
    name = "SNSInvalidTopicFault";
    $fault = "client";
    constructor(opts) {
        super({
            name: "SNSInvalidTopicFault",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, SNSInvalidTopicFault.prototype);
    }
}
export class SNSNoAuthorizationFault extends __BaseException {
    name = "SNSNoAuthorizationFault";
    $fault = "client";
    constructor(opts) {
        super({
            name: "SNSNoAuthorizationFault",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, SNSNoAuthorizationFault.prototype);
    }
}
export class S3ResourceNotFoundFault extends __BaseException {
    name = "S3ResourceNotFoundFault";
    $fault = "client";
    constructor(opts) {
        super({
            name: "S3ResourceNotFoundFault",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, S3ResourceNotFoundFault.prototype);
    }
}
export class InvalidSubnet extends __BaseException {
    name = "InvalidSubnet";
    $fault = "client";
    constructor(opts) {
        super({
            name: "InvalidSubnet",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, InvalidSubnet.prototype);
    }
}
export class ReplicationSubnetGroupDoesNotCoverEnoughAZs extends __BaseException {
    name = "ReplicationSubnetGroupDoesNotCoverEnoughAZs";
    $fault = "client";
    constructor(opts) {
        super({
            name: "ReplicationSubnetGroupDoesNotCoverEnoughAZs",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, ReplicationSubnetGroupDoesNotCoverEnoughAZs.prototype);
    }
}
export class InsufficientResourceCapacityFault extends __BaseException {
    name = "InsufficientResourceCapacityFault";
    $fault = "client";
    constructor(opts) {
        super({
            name: "InsufficientResourceCapacityFault",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, InsufficientResourceCapacityFault.prototype);
    }
}
export class StorageQuotaExceededFault extends __BaseException {
    name = "StorageQuotaExceededFault";
    $fault = "client";
    constructor(opts) {
        super({
            name: "StorageQuotaExceededFault",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, StorageQuotaExceededFault.prototype);
    }
}
export class CollectorNotFoundFault extends __BaseException {
    name = "CollectorNotFoundFault";
    $fault = "client";
    constructor(opts) {
        super({
            name: "CollectorNotFoundFault",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, CollectorNotFoundFault.prototype);
    }
}
export const EndpointSettingTypeValue = {
    BOOLEAN: "boolean",
    ENUM: "enum",
    INTEGER: "integer",
    STRING: "string",
};
export const ReleaseStatusValues = {
    BETA: "beta",
    PROD: "prod",
};
export const SourceType = {
    replication_instance: "replication-instance",
};
export var ErrorDetails;
(function (ErrorDetails) {
    ErrorDetails.visit = (value, visitor) => {
        if (value.defaultErrorDetails !== undefined)
            return visitor.defaultErrorDetails(value.defaultErrorDetails);
        return visitor._(value.$unknown[0], value.$unknown[1]);
    };
})(ErrorDetails || (ErrorDetails = {}));
export const CollectorStatus = {
    ACTIVE: "ACTIVE",
    UNREGISTERED: "UNREGISTERED",
};
export const VersionStatus = {
    OUTDATED: "OUTDATED",
    UNSUPPORTED: "UNSUPPORTED",
    UP_TO_DATE: "UP_TO_DATE",
};
export const RefreshSchemasStatusTypeValue = {
    FAILED: "failed",
    REFRESHING: "refreshing",
    SUCCESSFUL: "successful",
};
export const CreateDataMigrationMessageFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.SelectionRules && { SelectionRules: SENSITIVE_STRING }),
});
export const DataMigrationSettingsFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.SelectionRules && { SelectionRules: SENSITIVE_STRING }),
});
export const DataMigrationFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.DataMigrationSettings && {
        DataMigrationSettings: DataMigrationSettingsFilterSensitiveLog(obj.DataMigrationSettings),
    }),
    ...(obj.PublicIpAddresses && { PublicIpAddresses: SENSITIVE_STRING }),
});
export const CreateDataMigrationResponseFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.DataMigration && { DataMigration: DataMigrationFilterSensitiveLog(obj.DataMigration) }),
});
export const DocDbSettingsFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.Password && { Password: SENSITIVE_STRING }),
});
export const GcpMySQLSettingsFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.Password && { Password: SENSITIVE_STRING }),
});
export const IBMDb2SettingsFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.Password && { Password: SENSITIVE_STRING }),
});
export const KafkaSettingsFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.SslClientKeyPassword && { SslClientKeyPassword: SENSITIVE_STRING }),
    ...(obj.SaslPassword && { SaslPassword: SENSITIVE_STRING }),
});
export const MicrosoftSQLServerSettingsFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.Password && { Password: SENSITIVE_STRING }),
});
export const MongoDbSettingsFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.Password && { Password: SENSITIVE_STRING }),
});
export const MySQLSettingsFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.Password && { Password: SENSITIVE_STRING }),
});
export const OracleSettingsFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.AsmPassword && { AsmPassword: SENSITIVE_STRING }),
    ...(obj.Password && { Password: SENSITIVE_STRING }),
    ...(obj.SecurityDbEncryption && { SecurityDbEncryption: SENSITIVE_STRING }),
});
export const PostgreSQLSettingsFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.Password && { Password: SENSITIVE_STRING }),
});
export const RedisSettingsFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.AuthPassword && { AuthPassword: SENSITIVE_STRING }),
});
export const RedshiftSettingsFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.Password && { Password: SENSITIVE_STRING }),
});
export const SybaseSettingsFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.Password && { Password: SENSITIVE_STRING }),
});
export const CreateEndpointMessageFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.Password && { Password: SENSITIVE_STRING }),
    ...(obj.MongoDbSettings && { MongoDbSettings: MongoDbSettingsFilterSensitiveLog(obj.MongoDbSettings) }),
    ...(obj.KafkaSettings && { KafkaSettings: KafkaSettingsFilterSensitiveLog(obj.KafkaSettings) }),
    ...(obj.RedshiftSettings && { RedshiftSettings: RedshiftSettingsFilterSensitiveLog(obj.RedshiftSettings) }),
    ...(obj.PostgreSQLSettings && { PostgreSQLSettings: PostgreSQLSettingsFilterSensitiveLog(obj.PostgreSQLSettings) }),
    ...(obj.MySQLSettings && { MySQLSettings: MySQLSettingsFilterSensitiveLog(obj.MySQLSettings) }),
    ...(obj.OracleSettings && { OracleSettings: OracleSettingsFilterSensitiveLog(obj.OracleSettings) }),
    ...(obj.SybaseSettings && { SybaseSettings: SybaseSettingsFilterSensitiveLog(obj.SybaseSettings) }),
    ...(obj.MicrosoftSQLServerSettings && {
        MicrosoftSQLServerSettings: MicrosoftSQLServerSettingsFilterSensitiveLog(obj.MicrosoftSQLServerSettings),
    }),
    ...(obj.IBMDb2Settings && { IBMDb2Settings: IBMDb2SettingsFilterSensitiveLog(obj.IBMDb2Settings) }),
    ...(obj.DocDbSettings && { DocDbSettings: DocDbSettingsFilterSensitiveLog(obj.DocDbSettings) }),
    ...(obj.RedisSettings && { RedisSettings: RedisSettingsFilterSensitiveLog(obj.RedisSettings) }),
    ...(obj.GcpMySQLSettings && { GcpMySQLSettings: GcpMySQLSettingsFilterSensitiveLog(obj.GcpMySQLSettings) }),
});
export const EndpointFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.MongoDbSettings && { MongoDbSettings: MongoDbSettingsFilterSensitiveLog(obj.MongoDbSettings) }),
    ...(obj.KafkaSettings && { KafkaSettings: KafkaSettingsFilterSensitiveLog(obj.KafkaSettings) }),
    ...(obj.RedshiftSettings && { RedshiftSettings: RedshiftSettingsFilterSensitiveLog(obj.RedshiftSettings) }),
    ...(obj.PostgreSQLSettings && { PostgreSQLSettings: PostgreSQLSettingsFilterSensitiveLog(obj.PostgreSQLSettings) }),
    ...(obj.MySQLSettings && { MySQLSettings: MySQLSettingsFilterSensitiveLog(obj.MySQLSettings) }),
    ...(obj.OracleSettings && { OracleSettings: OracleSettingsFilterSensitiveLog(obj.OracleSettings) }),
    ...(obj.SybaseSettings && { SybaseSettings: SybaseSettingsFilterSensitiveLog(obj.SybaseSettings) }),
    ...(obj.MicrosoftSQLServerSettings && {
        MicrosoftSQLServerSettings: MicrosoftSQLServerSettingsFilterSensitiveLog(obj.MicrosoftSQLServerSettings),
    }),
    ...(obj.IBMDb2Settings && { IBMDb2Settings: IBMDb2SettingsFilterSensitiveLog(obj.IBMDb2Settings) }),
    ...(obj.DocDbSettings && { DocDbSettings: DocDbSettingsFilterSensitiveLog(obj.DocDbSettings) }),
    ...(obj.RedisSettings && { RedisSettings: RedisSettingsFilterSensitiveLog(obj.RedisSettings) }),
    ...(obj.GcpMySQLSettings && { GcpMySQLSettings: GcpMySQLSettingsFilterSensitiveLog(obj.GcpMySQLSettings) }),
});
export const CreateEndpointResponseFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.Endpoint && { Endpoint: EndpointFilterSensitiveLog(obj.Endpoint) }),
});
export const DeleteDataMigrationResponseFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.DataMigration && { DataMigration: DataMigrationFilterSensitiveLog(obj.DataMigration) }),
});
export const DeleteEndpointResponseFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.Endpoint && { Endpoint: EndpointFilterSensitiveLog(obj.Endpoint) }),
});
export const DescribeDataMigrationsResponseFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.DataMigrations && {
        DataMigrations: obj.DataMigrations.map((item) => DataMigrationFilterSensitiveLog(item)),
    }),
});
export const DescribeEndpointsResponseFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.Endpoints && { Endpoints: obj.Endpoints.map((item) => EndpointFilterSensitiveLog(item)) }),
});
export const ReplicationTaskAssessmentResultFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.S3ObjectUrl && { S3ObjectUrl: SENSITIVE_STRING }),
});
export const DescribeReplicationTaskAssessmentResultsResponseFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.ReplicationTaskAssessmentResults && {
        ReplicationTaskAssessmentResults: obj.ReplicationTaskAssessmentResults.map((item) => ReplicationTaskAssessmentResultFilterSensitiveLog(item)),
    }),
});
