import { ExceptionOptionType as __ExceptionOptionType } from "@smithy/smithy-client";
import { DatabaseMigrationServiceServiceException as __BaseException } from "./DatabaseMigrationServiceServiceException";
export declare class AccessDeniedFault extends __BaseException {
  readonly name: "AccessDeniedFault";
  readonly $fault: "client";
  constructor(opts: __ExceptionOptionType<AccessDeniedFault, __BaseException>);
}
export interface AccountQuota {
  AccountQuotaName?: string | undefined;
  Used?: number | undefined;
  Max?: number | undefined;
}
export interface Tag {
  Key?: string | undefined;
  Value?: string | undefined;
  ResourceArn?: string | undefined;
}
export interface AddTagsToResourceMessage {
  ResourceArn: string | undefined;
  Tags: Tag[] | undefined;
}
export interface AddTagsToResourceResponse {}
export declare class InvalidResourceStateFault extends __BaseException {
  readonly name: "InvalidResourceStateFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<InvalidResourceStateFault, __BaseException>
  );
}
export declare class ResourceNotFoundFault extends __BaseException {
  readonly name: "ResourceNotFoundFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<ResourceNotFoundFault, __BaseException>
  );
}
export interface ApplyPendingMaintenanceActionMessage {
  ReplicationInstanceArn: string | undefined;
  ApplyAction: string | undefined;
  OptInType: string | undefined;
}
export interface PendingMaintenanceAction {
  Action?: string | undefined;
  AutoAppliedAfterDate?: Date | undefined;
  ForcedApplyDate?: Date | undefined;
  OptInStatus?: string | undefined;
  CurrentApplyDate?: Date | undefined;
  Description?: string | undefined;
}
export interface ResourcePendingMaintenanceActions {
  ResourceIdentifier?: string | undefined;
  PendingMaintenanceActionDetails?: PendingMaintenanceAction[] | undefined;
}
export interface ApplyPendingMaintenanceActionResponse {
  ResourcePendingMaintenanceActions?:
    | ResourcePendingMaintenanceActions
    | undefined;
}
export interface RecommendationSettings {
  InstanceSizingType: string | undefined;
  WorkloadType: string | undefined;
}
export interface StartRecommendationsRequestEntry {
  DatabaseId: string | undefined;
  Settings: RecommendationSettings | undefined;
}
export interface BatchStartRecommendationsRequest {
  Data?: StartRecommendationsRequestEntry[] | undefined;
}
export interface BatchStartRecommendationsErrorEntry {
  DatabaseId?: string | undefined;
  Message?: string | undefined;
  Code?: string | undefined;
}
export interface BatchStartRecommendationsResponse {
  ErrorEntries?: BatchStartRecommendationsErrorEntry[] | undefined;
}
export interface CancelReplicationTaskAssessmentRunMessage {
  ReplicationTaskAssessmentRunArn: string | undefined;
}
export interface ReplicationTaskAssessmentRunProgress {
  IndividualAssessmentCount?: number | undefined;
  IndividualAssessmentCompletedCount?: number | undefined;
}
export interface ReplicationTaskAssessmentRunResultStatistic {
  Passed?: number | undefined;
  Failed?: number | undefined;
  Error?: number | undefined;
  Warning?: number | undefined;
  Cancelled?: number | undefined;
}
export interface ReplicationTaskAssessmentRun {
  ReplicationTaskAssessmentRunArn?: string | undefined;
  ReplicationTaskArn?: string | undefined;
  Status?: string | undefined;
  ReplicationTaskAssessmentRunCreationDate?: Date | undefined;
  AssessmentProgress?: ReplicationTaskAssessmentRunProgress | undefined;
  LastFailureMessage?: string | undefined;
  ServiceAccessRoleArn?: string | undefined;
  ResultLocationBucket?: string | undefined;
  ResultLocationFolder?: string | undefined;
  ResultEncryptionMode?: string | undefined;
  ResultKmsKeyArn?: string | undefined;
  AssessmentRunName?: string | undefined;
  IsLatestTaskAssessmentRun?: boolean | undefined;
  ResultStatistic?: ReplicationTaskAssessmentRunResultStatistic | undefined;
}
export interface CancelReplicationTaskAssessmentRunResponse {
  ReplicationTaskAssessmentRun?: ReplicationTaskAssessmentRun | undefined;
}
export declare const MigrationTypeValue: {
  readonly CDC: "cdc";
  readonly FULL_LOAD: "full-load";
  readonly FULL_LOAD_AND_CDC: "full-load-and-cdc";
};
export type MigrationTypeValue =
  (typeof MigrationTypeValue)[keyof typeof MigrationTypeValue];
export interface SourceDataSetting {
  CDCStartPosition?: string | undefined;
  CDCStartTime?: Date | undefined;
  CDCStopTime?: Date | undefined;
  SlotName?: string | undefined;
}
export declare const TablePreparationMode: {
  readonly DO_NOTHING: "do-nothing";
  readonly DROP_TABLES_ON_TARGET: "drop-tables-on-target";
  readonly TRUNCATE: "truncate";
};
export type TablePreparationMode =
  (typeof TablePreparationMode)[keyof typeof TablePreparationMode];
export interface TargetDataSetting {
  TablePreparationMode?: TablePreparationMode | undefined;
}
export interface CreateDataMigrationMessage {
  DataMigrationName?: string | undefined;
  MigrationProjectIdentifier: string | undefined;
  DataMigrationType: MigrationTypeValue | undefined;
  ServiceAccessRoleArn: string | undefined;
  EnableCloudwatchLogs?: boolean | undefined;
  SourceDataSettings?: SourceDataSetting[] | undefined;
  TargetDataSettings?: TargetDataSetting[] | undefined;
  NumberOfJobs?: number | undefined;
  Tags?: Tag[] | undefined;
  SelectionRules?: string | undefined;
}
export interface DataMigrationSettings {
  NumberOfJobs?: number | undefined;
  CloudwatchLogsEnabled?: boolean | undefined;
  SelectionRules?: string | undefined;
}
export interface DataMigrationStatistics {
  TablesLoaded?: number | undefined;
  ElapsedTimeMillis?: number | undefined;
  TablesLoading?: number | undefined;
  FullLoadPercentage?: number | undefined;
  CDCLatency?: number | undefined;
  TablesQueued?: number | undefined;
  TablesErrored?: number | undefined;
  StartTime?: Date | undefined;
  StopTime?: Date | undefined;
}
export interface DataMigration {
  DataMigrationName?: string | undefined;
  DataMigrationArn?: string | undefined;
  DataMigrationCreateTime?: Date | undefined;
  DataMigrationStartTime?: Date | undefined;
  DataMigrationEndTime?: Date | undefined;
  ServiceAccessRoleArn?: string | undefined;
  MigrationProjectArn?: string | undefined;
  DataMigrationType?: MigrationTypeValue | undefined;
  DataMigrationSettings?: DataMigrationSettings | undefined;
  SourceDataSettings?: SourceDataSetting[] | undefined;
  TargetDataSettings?: TargetDataSetting[] | undefined;
  DataMigrationStatistics?: DataMigrationStatistics | undefined;
  DataMigrationStatus?: string | undefined;
  PublicIpAddresses?: string[] | undefined;
  DataMigrationCidrBlocks?: string[] | undefined;
  LastFailureMessage?: string | undefined;
  StopReason?: string | undefined;
}
export interface CreateDataMigrationResponse {
  DataMigration?: DataMigration | undefined;
}
export declare class FailedDependencyFault extends __BaseException {
  readonly name: "FailedDependencyFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<FailedDependencyFault, __BaseException>
  );
}
export declare class InvalidOperationFault extends __BaseException {
  readonly name: "InvalidOperationFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<InvalidOperationFault, __BaseException>
  );
}
export declare class ResourceAlreadyExistsFault extends __BaseException {
  readonly name: "ResourceAlreadyExistsFault";
  readonly $fault: "client";
  resourceArn?: string | undefined;
  constructor(
    opts: __ExceptionOptionType<ResourceAlreadyExistsFault, __BaseException>
  );
}
export declare class ResourceQuotaExceededFault extends __BaseException {
  readonly name: "ResourceQuotaExceededFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<ResourceQuotaExceededFault, __BaseException>
  );
}
export declare const DmsSslModeValue: {
  readonly NONE: "none";
  readonly REQUIRE: "require";
  readonly VERIFY_CA: "verify-ca";
  readonly VERIFY_FULL: "verify-full";
};
export type DmsSslModeValue =
  (typeof DmsSslModeValue)[keyof typeof DmsSslModeValue];
export interface DocDbDataProviderSettings {
  ServerName?: string | undefined;
  Port?: number | undefined;
  DatabaseName?: string | undefined;
  SslMode?: DmsSslModeValue | undefined;
  CertificateArn?: string | undefined;
}
export interface MariaDbDataProviderSettings {
  ServerName?: string | undefined;
  Port?: number | undefined;
  SslMode?: DmsSslModeValue | undefined;
  CertificateArn?: string | undefined;
}
export interface MicrosoftSqlServerDataProviderSettings {
  ServerName?: string | undefined;
  Port?: number | undefined;
  DatabaseName?: string | undefined;
  SslMode?: DmsSslModeValue | undefined;
  CertificateArn?: string | undefined;
}
export declare const AuthMechanismValue: {
  readonly DEFAULT: "default";
  readonly MONGODB_CR: "mongodb_cr";
  readonly SCRAM_SHA_1: "scram_sha_1";
};
export type AuthMechanismValue =
  (typeof AuthMechanismValue)[keyof typeof AuthMechanismValue];
export declare const AuthTypeValue: {
  readonly NO: "no";
  readonly PASSWORD: "password";
};
export type AuthTypeValue = (typeof AuthTypeValue)[keyof typeof AuthTypeValue];
export interface MongoDbDataProviderSettings {
  ServerName?: string | undefined;
  Port?: number | undefined;
  DatabaseName?: string | undefined;
  SslMode?: DmsSslModeValue | undefined;
  CertificateArn?: string | undefined;
  AuthType?: AuthTypeValue | undefined;
  AuthSource?: string | undefined;
  AuthMechanism?: AuthMechanismValue | undefined;
}
export interface MySqlDataProviderSettings {
  ServerName?: string | undefined;
  Port?: number | undefined;
  SslMode?: DmsSslModeValue | undefined;
  CertificateArn?: string | undefined;
}
export interface OracleDataProviderSettings {
  ServerName?: string | undefined;
  Port?: number | undefined;
  DatabaseName?: string | undefined;
  SslMode?: DmsSslModeValue | undefined;
  CertificateArn?: string | undefined;
  AsmServer?: string | undefined;
  SecretsManagerOracleAsmSecretId?: string | undefined;
  SecretsManagerOracleAsmAccessRoleArn?: string | undefined;
  SecretsManagerSecurityDbEncryptionSecretId?: string | undefined;
  SecretsManagerSecurityDbEncryptionAccessRoleArn?: string | undefined;
}
export interface PostgreSqlDataProviderSettings {
  ServerName?: string | undefined;
  Port?: number | undefined;
  DatabaseName?: string | undefined;
  SslMode?: DmsSslModeValue | undefined;
  CertificateArn?: string | undefined;
}
export interface RedshiftDataProviderSettings {
  ServerName?: string | undefined;
  Port?: number | undefined;
  DatabaseName?: string | undefined;
}
export type DataProviderSettings =
  | DataProviderSettings.DocDbSettingsMember
  | DataProviderSettings.MariaDbSettingsMember
  | DataProviderSettings.MicrosoftSqlServerSettingsMember
  | DataProviderSettings.MongoDbSettingsMember
  | DataProviderSettings.MySqlSettingsMember
  | DataProviderSettings.OracleSettingsMember
  | DataProviderSettings.PostgreSqlSettingsMember
  | DataProviderSettings.RedshiftSettingsMember
  | DataProviderSettings.$UnknownMember;
export declare namespace DataProviderSettings {
  interface RedshiftSettingsMember {
    RedshiftSettings: RedshiftDataProviderSettings;
    PostgreSqlSettings?: never;
    MySqlSettings?: never;
    OracleSettings?: never;
    MicrosoftSqlServerSettings?: never;
    DocDbSettings?: never;
    MariaDbSettings?: never;
    MongoDbSettings?: never;
    $unknown?: never;
  }
  interface PostgreSqlSettingsMember {
    RedshiftSettings?: never;
    PostgreSqlSettings: PostgreSqlDataProviderSettings;
    MySqlSettings?: never;
    OracleSettings?: never;
    MicrosoftSqlServerSettings?: never;
    DocDbSettings?: never;
    MariaDbSettings?: never;
    MongoDbSettings?: never;
    $unknown?: never;
  }
  interface MySqlSettingsMember {
    RedshiftSettings?: never;
    PostgreSqlSettings?: never;
    MySqlSettings: MySqlDataProviderSettings;
    OracleSettings?: never;
    MicrosoftSqlServerSettings?: never;
    DocDbSettings?: never;
    MariaDbSettings?: never;
    MongoDbSettings?: never;
    $unknown?: never;
  }
  interface OracleSettingsMember {
    RedshiftSettings?: never;
    PostgreSqlSettings?: never;
    MySqlSettings?: never;
    OracleSettings: OracleDataProviderSettings;
    MicrosoftSqlServerSettings?: never;
    DocDbSettings?: never;
    MariaDbSettings?: never;
    MongoDbSettings?: never;
    $unknown?: never;
  }
  interface MicrosoftSqlServerSettingsMember {
    RedshiftSettings?: never;
    PostgreSqlSettings?: never;
    MySqlSettings?: never;
    OracleSettings?: never;
    MicrosoftSqlServerSettings: MicrosoftSqlServerDataProviderSettings;
    DocDbSettings?: never;
    MariaDbSettings?: never;
    MongoDbSettings?: never;
    $unknown?: never;
  }
  interface DocDbSettingsMember {
    RedshiftSettings?: never;
    PostgreSqlSettings?: never;
    MySqlSettings?: never;
    OracleSettings?: never;
    MicrosoftSqlServerSettings?: never;
    DocDbSettings: DocDbDataProviderSettings;
    MariaDbSettings?: never;
    MongoDbSettings?: never;
    $unknown?: never;
  }
  interface MariaDbSettingsMember {
    RedshiftSettings?: never;
    PostgreSqlSettings?: never;
    MySqlSettings?: never;
    OracleSettings?: never;
    MicrosoftSqlServerSettings?: never;
    DocDbSettings?: never;
    MariaDbSettings: MariaDbDataProviderSettings;
    MongoDbSettings?: never;
    $unknown?: never;
  }
  interface MongoDbSettingsMember {
    RedshiftSettings?: never;
    PostgreSqlSettings?: never;
    MySqlSettings?: never;
    OracleSettings?: never;
    MicrosoftSqlServerSettings?: never;
    DocDbSettings?: never;
    MariaDbSettings?: never;
    MongoDbSettings: MongoDbDataProviderSettings;
    $unknown?: never;
  }
  interface $UnknownMember {
    RedshiftSettings?: never;
    PostgreSqlSettings?: never;
    MySqlSettings?: never;
    OracleSettings?: never;
    MicrosoftSqlServerSettings?: never;
    DocDbSettings?: never;
    MariaDbSettings?: never;
    MongoDbSettings?: never;
    $unknown: [string, any];
  }
  interface Visitor<T> {
    RedshiftSettings: (value: RedshiftDataProviderSettings) => T;
    PostgreSqlSettings: (value: PostgreSqlDataProviderSettings) => T;
    MySqlSettings: (value: MySqlDataProviderSettings) => T;
    OracleSettings: (value: OracleDataProviderSettings) => T;
    MicrosoftSqlServerSettings: (
      value: MicrosoftSqlServerDataProviderSettings
    ) => T;
    DocDbSettings: (value: DocDbDataProviderSettings) => T;
    MariaDbSettings: (value: MariaDbDataProviderSettings) => T;
    MongoDbSettings: (value: MongoDbDataProviderSettings) => T;
    _: (name: string, value: any) => T;
  }
  const visit: <T>(value: DataProviderSettings, visitor: Visitor<T>) => T;
}
export interface CreateDataProviderMessage {
  DataProviderName?: string | undefined;
  Description?: string | undefined;
  Engine: string | undefined;
  Settings: DataProviderSettings | undefined;
  Tags?: Tag[] | undefined;
}
export interface DataProvider {
  DataProviderName?: string | undefined;
  DataProviderArn?: string | undefined;
  DataProviderCreationTime?: Date | undefined;
  Description?: string | undefined;
  Engine?: string | undefined;
  Settings?: DataProviderSettings | undefined;
}
export interface CreateDataProviderResponse {
  DataProvider?: DataProvider | undefined;
}
export interface DmsTransferSettings {
  ServiceAccessRoleArn?: string | undefined;
  BucketName?: string | undefined;
}
export declare const NestingLevelValue: {
  readonly NONE: "none";
  readonly ONE: "one";
};
export type NestingLevelValue =
  (typeof NestingLevelValue)[keyof typeof NestingLevelValue];
export interface DocDbSettings {
  Username?: string | undefined;
  Password?: string | undefined;
  ServerName?: string | undefined;
  Port?: number | undefined;
  DatabaseName?: string | undefined;
  NestingLevel?: NestingLevelValue | undefined;
  ExtractDocId?: boolean | undefined;
  DocsToInvestigate?: number | undefined;
  KmsKeyId?: string | undefined;
  SecretsManagerAccessRoleArn?: string | undefined;
  SecretsManagerSecretId?: string | undefined;
  UseUpdateLookUp?: boolean | undefined;
  ReplicateShardCollections?: boolean | undefined;
}
export interface DynamoDbSettings {
  ServiceAccessRoleArn: string | undefined;
}
export interface ElasticsearchSettings {
  ServiceAccessRoleArn: string | undefined;
  EndpointUri: string | undefined;
  FullLoadErrorPercentage?: number | undefined;
  ErrorRetryDuration?: number | undefined;
  UseNewMappingType?: boolean | undefined;
}
export declare const ReplicationEndpointTypeValue: {
  readonly SOURCE: "source";
  readonly TARGET: "target";
};
export type ReplicationEndpointTypeValue =
  (typeof ReplicationEndpointTypeValue)[keyof typeof ReplicationEndpointTypeValue];
export declare const TargetDbType: {
  readonly MULTIPLE_DATABASES: "multiple-databases";
  readonly SPECIFIC_DATABASE: "specific-database";
};
export type TargetDbType = (typeof TargetDbType)[keyof typeof TargetDbType];
export interface GcpMySQLSettings {
  AfterConnectScript?: string | undefined;
  CleanSourceMetadataOnMismatch?: boolean | undefined;
  DatabaseName?: string | undefined;
  EventsPollInterval?: number | undefined;
  TargetDbType?: TargetDbType | undefined;
  MaxFileSize?: number | undefined;
  ParallelLoadThreads?: number | undefined;
  Password?: string | undefined;
  Port?: number | undefined;
  ServerName?: string | undefined;
  ServerTimezone?: string | undefined;
  Username?: string | undefined;
  SecretsManagerAccessRoleArn?: string | undefined;
  SecretsManagerSecretId?: string | undefined;
}
export interface IBMDb2Settings {
  DatabaseName?: string | undefined;
  Password?: string | undefined;
  Port?: number | undefined;
  ServerName?: string | undefined;
  SetDataCaptureChanges?: boolean | undefined;
  CurrentLsn?: string | undefined;
  MaxKBytesPerRead?: number | undefined;
  Username?: string | undefined;
  SecretsManagerAccessRoleArn?: string | undefined;
  SecretsManagerSecretId?: string | undefined;
  LoadTimeout?: number | undefined;
  WriteBufferSize?: number | undefined;
  MaxFileSize?: number | undefined;
  KeepCsvFiles?: boolean | undefined;
}
export declare const MessageFormatValue: {
  readonly JSON: "json";
  readonly JSON_UNFORMATTED: "json-unformatted";
};
export type MessageFormatValue =
  (typeof MessageFormatValue)[keyof typeof MessageFormatValue];
export declare const KafkaSaslMechanism: {
  readonly PLAIN: "plain";
  readonly SCRAM_SHA_512: "scram-sha-512";
};
export type KafkaSaslMechanism =
  (typeof KafkaSaslMechanism)[keyof typeof KafkaSaslMechanism];
export declare const KafkaSecurityProtocol: {
  readonly PLAINTEXT: "plaintext";
  readonly SASL_SSL: "sasl-ssl";
  readonly SSL_AUTHENTICATION: "ssl-authentication";
  readonly SSL_ENCRYPTION: "ssl-encryption";
};
export type KafkaSecurityProtocol =
  (typeof KafkaSecurityProtocol)[keyof typeof KafkaSecurityProtocol];
export declare const KafkaSslEndpointIdentificationAlgorithm: {
  readonly HTTPS: "https";
  readonly NONE: "none";
};
export type KafkaSslEndpointIdentificationAlgorithm =
  (typeof KafkaSslEndpointIdentificationAlgorithm)[keyof typeof KafkaSslEndpointIdentificationAlgorithm];
export interface KafkaSettings {
  Broker?: string | undefined;
  Topic?: string | undefined;
  MessageFormat?: MessageFormatValue | undefined;
  IncludeTransactionDetails?: boolean | undefined;
  IncludePartitionValue?: boolean | undefined;
  PartitionIncludeSchemaTable?: boolean | undefined;
  IncludeTableAlterOperations?: boolean | undefined;
  IncludeControlDetails?: boolean | undefined;
  MessageMaxBytes?: number | undefined;
  IncludeNullAndEmpty?: boolean | undefined;
  SecurityProtocol?: KafkaSecurityProtocol | undefined;
  SslClientCertificateArn?: string | undefined;
  SslClientKeyArn?: string | undefined;
  SslClientKeyPassword?: string | undefined;
  SslCaCertificateArn?: string | undefined;
  SaslUsername?: string | undefined;
  SaslPassword?: string | undefined;
  NoHexPrefix?: boolean | undefined;
  SaslMechanism?: KafkaSaslMechanism | undefined;
  SslEndpointIdentificationAlgorithm?:
    | KafkaSslEndpointIdentificationAlgorithm
    | undefined;
  UseLargeIntegerValue?: boolean | undefined;
}
export interface KinesisSettings {
  StreamArn?: string | undefined;
  MessageFormat?: MessageFormatValue | undefined;
  ServiceAccessRoleArn?: string | undefined;
  IncludeTransactionDetails?: boolean | undefined;
  IncludePartitionValue?: boolean | undefined;
  PartitionIncludeSchemaTable?: boolean | undefined;
  IncludeTableAlterOperations?: boolean | undefined;
  IncludeControlDetails?: boolean | undefined;
  IncludeNullAndEmpty?: boolean | undefined;
  NoHexPrefix?: boolean | undefined;
  UseLargeIntegerValue?: boolean | undefined;
}
export declare const SqlServerAuthenticationMethod: {
  readonly Kerberos: "kerberos";
  readonly Password: "password";
};
export type SqlServerAuthenticationMethod =
  (typeof SqlServerAuthenticationMethod)[keyof typeof SqlServerAuthenticationMethod];
export declare const SafeguardPolicy: {
  readonly EXCLUSIVE_AUTOMATIC_TRUNCATION: "exclusive-automatic-truncation";
  readonly RELY_ON_SQL_SERVER_REPLICATION_AGENT: "rely-on-sql-server-replication-agent";
  readonly SHARED_AUTOMATIC_TRUNCATION: "shared-automatic-truncation";
};
export type SafeguardPolicy =
  (typeof SafeguardPolicy)[keyof typeof SafeguardPolicy];
export declare const TlogAccessMode: {
  readonly BackupOnly: "BackupOnly";
  readonly PreferBackup: "PreferBackup";
  readonly PreferTlog: "PreferTlog";
  readonly TlogOnly: "TlogOnly";
};
export type TlogAccessMode =
  (typeof TlogAccessMode)[keyof typeof TlogAccessMode];
export interface MicrosoftSQLServerSettings {
  Port?: number | undefined;
  BcpPacketSize?: number | undefined;
  DatabaseName?: string | undefined;
  ControlTablesFileGroup?: string | undefined;
  Password?: string | undefined;
  QuerySingleAlwaysOnNode?: boolean | undefined;
  ReadBackupOnly?: boolean | undefined;
  SafeguardPolicy?: SafeguardPolicy | undefined;
  ServerName?: string | undefined;
  Username?: string | undefined;
  UseBcpFullLoad?: boolean | undefined;
  UseThirdPartyBackupDevice?: boolean | undefined;
  SecretsManagerAccessRoleArn?: string | undefined;
  SecretsManagerSecretId?: string | undefined;
  TrimSpaceInChar?: boolean | undefined;
  TlogAccessMode?: TlogAccessMode | undefined;
  ForceLobLookup?: boolean | undefined;
  AuthenticationMethod?: SqlServerAuthenticationMethod | undefined;
}
export interface MongoDbSettings {
  Username?: string | undefined;
  Password?: string | undefined;
  ServerName?: string | undefined;
  Port?: number | undefined;
  DatabaseName?: string | undefined;
  AuthType?: AuthTypeValue | undefined;
  AuthMechanism?: AuthMechanismValue | undefined;
  NestingLevel?: NestingLevelValue | undefined;
  ExtractDocId?: string | undefined;
  DocsToInvestigate?: string | undefined;
  AuthSource?: string | undefined;
  KmsKeyId?: string | undefined;
  SecretsManagerAccessRoleArn?: string | undefined;
  SecretsManagerSecretId?: string | undefined;
  UseUpdateLookUp?: boolean | undefined;
  ReplicateShardCollections?: boolean | undefined;
}
export interface MySQLSettings {
  AfterConnectScript?: string | undefined;
  CleanSourceMetadataOnMismatch?: boolean | undefined;
  DatabaseName?: string | undefined;
  EventsPollInterval?: number | undefined;
  TargetDbType?: TargetDbType | undefined;
  MaxFileSize?: number | undefined;
  ParallelLoadThreads?: number | undefined;
  Password?: string | undefined;
  Port?: number | undefined;
  ServerName?: string | undefined;
  ServerTimezone?: string | undefined;
  Username?: string | undefined;
  SecretsManagerAccessRoleArn?: string | undefined;
  SecretsManagerSecretId?: string | undefined;
  ExecuteTimeout?: number | undefined;
}
export interface NeptuneSettings {
  ServiceAccessRoleArn?: string | undefined;
  S3BucketName: string | undefined;
  S3BucketFolder: string | undefined;
  ErrorRetryDuration?: number | undefined;
  MaxFileSize?: number | undefined;
  MaxRetryCount?: number | undefined;
  IamAuthEnabled?: boolean | undefined;
}
export declare const OracleAuthenticationMethod: {
  readonly Kerberos: "kerberos";
  readonly Password: "password";
};
export type OracleAuthenticationMethod =
  (typeof OracleAuthenticationMethod)[keyof typeof OracleAuthenticationMethod];
export declare const CharLengthSemantics: {
  readonly BYTE: "byte";
  readonly CHAR: "char";
  readonly DEFAULT: "default";
};
export type CharLengthSemantics =
  (typeof CharLengthSemantics)[keyof typeof CharLengthSemantics];
export interface OracleSettings {
  AddSupplementalLogging?: boolean | undefined;
  ArchivedLogDestId?: number | undefined;
  AdditionalArchivedLogDestId?: number | undefined;
  ExtraArchivedLogDestIds?: number[] | undefined;
  AllowSelectNestedTables?: boolean | undefined;
  ParallelAsmReadThreads?: number | undefined;
  ReadAheadBlocks?: number | undefined;
  AccessAlternateDirectly?: boolean | undefined;
  UseAlternateFolderForOnline?: boolean | undefined;
  OraclePathPrefix?: string | undefined;
  UsePathPrefix?: string | undefined;
  ReplacePathPrefix?: boolean | undefined;
  EnableHomogenousTablespace?: boolean | undefined;
  DirectPathNoLog?: boolean | undefined;
  ArchivedLogsOnly?: boolean | undefined;
  AsmPassword?: string | undefined;
  AsmServer?: string | undefined;
  AsmUser?: string | undefined;
  CharLengthSemantics?: CharLengthSemantics | undefined;
  DatabaseName?: string | undefined;
  DirectPathParallelLoad?: boolean | undefined;
  FailTasksOnLobTruncation?: boolean | undefined;
  NumberDatatypeScale?: number | undefined;
  Password?: string | undefined;
  Port?: number | undefined;
  ReadTableSpaceName?: boolean | undefined;
  RetryInterval?: number | undefined;
  SecurityDbEncryption?: string | undefined;
  SecurityDbEncryptionName?: string | undefined;
  ServerName?: string | undefined;
  SpatialDataOptionToGeoJsonFunctionName?: string | undefined;
  StandbyDelayTime?: number | undefined;
  Username?: string | undefined;
  UseBFile?: boolean | undefined;
  UseDirectPathFullLoad?: boolean | undefined;
  UseLogminerReader?: boolean | undefined;
  SecretsManagerAccessRoleArn?: string | undefined;
  SecretsManagerSecretId?: string | undefined;
  SecretsManagerOracleAsmAccessRoleArn?: string | undefined;
  SecretsManagerOracleAsmSecretId?: string | undefined;
  TrimSpaceInChar?: boolean | undefined;
  ConvertTimestampWithZoneToUTC?: boolean | undefined;
  OpenTransactionWindow?: number | undefined;
  AuthenticationMethod?: OracleAuthenticationMethod | undefined;
}
export declare const DatabaseMode: {
  readonly BABELFISH: "babelfish";
  readonly DEFAULT: "default";
};
export type DatabaseMode = (typeof DatabaseMode)[keyof typeof DatabaseMode];
export declare const LongVarcharMappingType: {
  readonly CLOB: "clob";
  readonly NCLOB: "nclob";
  readonly WSTRING: "wstring";
};
export type LongVarcharMappingType =
  (typeof LongVarcharMappingType)[keyof typeof LongVarcharMappingType];
export declare const PluginNameValue: {
  readonly NO_PREFERENCE: "no-preference";
  readonly PGLOGICAL: "pglogical";
  readonly TEST_DECODING: "test-decoding";
};
export type PluginNameValue =
  (typeof PluginNameValue)[keyof typeof PluginNameValue];
export interface PostgreSQLSettings {
  AfterConnectScript?: string | undefined;
  CaptureDdls?: boolean | undefined;
  MaxFileSize?: number | undefined;
  DatabaseName?: string | undefined;
  DdlArtifactsSchema?: string | undefined;
  ExecuteTimeout?: number | undefined;
  FailTasksOnLobTruncation?: boolean | undefined;
  HeartbeatEnable?: boolean | undefined;
  HeartbeatSchema?: string | undefined;
  HeartbeatFrequency?: number | undefined;
  Password?: string | undefined;
  Port?: number | undefined;
  ServerName?: string | undefined;
  Username?: string | undefined;
  SlotName?: string | undefined;
  PluginName?: PluginNameValue | undefined;
  SecretsManagerAccessRoleArn?: string | undefined;
  SecretsManagerSecretId?: string | undefined;
  TrimSpaceInChar?: boolean | undefined;
  MapBooleanAsBoolean?: boolean | undefined;
  MapJsonbAsClob?: boolean | undefined;
  MapLongVarcharAs?: LongVarcharMappingType | undefined;
  DatabaseMode?: DatabaseMode | undefined;
  BabelfishDatabaseName?: string | undefined;
  DisableUnicodeSourceFilter?: boolean | undefined;
}
export declare const RedisAuthTypeValue: {
  readonly AUTH_ROLE: "auth-role";
  readonly AUTH_TOKEN: "auth-token";
  readonly NONE: "none";
};
export type RedisAuthTypeValue =
  (typeof RedisAuthTypeValue)[keyof typeof RedisAuthTypeValue];
export declare const SslSecurityProtocolValue: {
  readonly PLAINTEXT: "plaintext";
  readonly SSL_ENCRYPTION: "ssl-encryption";
};
export type SslSecurityProtocolValue =
  (typeof SslSecurityProtocolValue)[keyof typeof SslSecurityProtocolValue];
export interface RedisSettings {
  ServerName: string | undefined;
  Port: number | undefined;
  SslSecurityProtocol?: SslSecurityProtocolValue | undefined;
  AuthType?: RedisAuthTypeValue | undefined;
  AuthUserName?: string | undefined;
  AuthPassword?: string | undefined;
  SslCaCertificateArn?: string | undefined;
}
export declare const EncryptionModeValue: {
  readonly SSE_KMS: "sse-kms";
  readonly SSE_S3: "sse-s3";
};
export type EncryptionModeValue =
  (typeof EncryptionModeValue)[keyof typeof EncryptionModeValue];
export interface RedshiftSettings {
  AcceptAnyDate?: boolean | undefined;
  AfterConnectScript?: string | undefined;
  BucketFolder?: string | undefined;
  BucketName?: string | undefined;
  CaseSensitiveNames?: boolean | undefined;
  CompUpdate?: boolean | undefined;
  ConnectionTimeout?: number | undefined;
  DatabaseName?: string | undefined;
  DateFormat?: string | undefined;
  EmptyAsNull?: boolean | undefined;
  EncryptionMode?: EncryptionModeValue | undefined;
  ExplicitIds?: boolean | undefined;
  FileTransferUploadStreams?: number | undefined;
  LoadTimeout?: number | undefined;
  MaxFileSize?: number | undefined;
  Password?: string | undefined;
  Port?: number | undefined;
  RemoveQuotes?: boolean | undefined;
  ReplaceInvalidChars?: string | undefined;
  ReplaceChars?: string | undefined;
  ServerName?: string | undefined;
  ServiceAccessRoleArn?: string | undefined;
  ServerSideEncryptionKmsKeyId?: string | undefined;
  TimeFormat?: string | undefined;
  TrimBlanks?: boolean | undefined;
  TruncateColumns?: boolean | undefined;
  Username?: string | undefined;
  WriteBufferSize?: number | undefined;
  SecretsManagerAccessRoleArn?: string | undefined;
  SecretsManagerSecretId?: string | undefined;
  MapBooleanAsBoolean?: boolean | undefined;
}
export declare const CannedAclForObjectsValue: {
  readonly AUTHENTICATED_READ: "authenticated-read";
  readonly AWS_EXEC_READ: "aws-exec-read";
  readonly BUCKET_OWNER_FULL_CONTROL: "bucket-owner-full-control";
  readonly BUCKET_OWNER_READ: "bucket-owner-read";
  readonly NONE: "none";
  readonly PRIVATE: "private";
  readonly PUBLIC_READ: "public-read";
  readonly PUBLIC_READ_WRITE: "public-read-write";
};
export type CannedAclForObjectsValue =
  (typeof CannedAclForObjectsValue)[keyof typeof CannedAclForObjectsValue];
export declare const CompressionTypeValue: {
  readonly GZIP: "gzip";
  readonly NONE: "none";
};
export type CompressionTypeValue =
  (typeof CompressionTypeValue)[keyof typeof CompressionTypeValue];
export declare const DataFormatValue: {
  readonly CSV: "csv";
  readonly PARQUET: "parquet";
};
export type DataFormatValue =
  (typeof DataFormatValue)[keyof typeof DataFormatValue];
export declare const DatePartitionDelimiterValue: {
  readonly DASH: "DASH";
  readonly NONE: "NONE";
  readonly SLASH: "SLASH";
  readonly UNDERSCORE: "UNDERSCORE";
};
export type DatePartitionDelimiterValue =
  (typeof DatePartitionDelimiterValue)[keyof typeof DatePartitionDelimiterValue];
export declare const DatePartitionSequenceValue: {
  readonly DDMMYYYY: "DDMMYYYY";
  readonly MMYYYYDD: "MMYYYYDD";
  readonly YYYYMM: "YYYYMM";
  readonly YYYYMMDD: "YYYYMMDD";
  readonly YYYYMMDDHH: "YYYYMMDDHH";
};
export type DatePartitionSequenceValue =
  (typeof DatePartitionSequenceValue)[keyof typeof DatePartitionSequenceValue];
export declare const EncodingTypeValue: {
  readonly PLAIN: "plain";
  readonly PLAIN_DICTIONARY: "plain-dictionary";
  readonly RLE_DICTIONARY: "rle-dictionary";
};
export type EncodingTypeValue =
  (typeof EncodingTypeValue)[keyof typeof EncodingTypeValue];
export declare const ParquetVersionValue: {
  readonly PARQUET_1_0: "parquet-1-0";
  readonly PARQUET_2_0: "parquet-2-0";
};
export type ParquetVersionValue =
  (typeof ParquetVersionValue)[keyof typeof ParquetVersionValue];
export interface S3Settings {
  ServiceAccessRoleArn?: string | undefined;
  ExternalTableDefinition?: string | undefined;
  CsvRowDelimiter?: string | undefined;
  CsvDelimiter?: string | undefined;
  BucketFolder?: string | undefined;
  BucketName?: string | undefined;
  CompressionType?: CompressionTypeValue | undefined;
  EncryptionMode?: EncryptionModeValue | undefined;
  ServerSideEncryptionKmsKeyId?: string | undefined;
  DataFormat?: DataFormatValue | undefined;
  EncodingType?: EncodingTypeValue | undefined;
  DictPageSizeLimit?: number | undefined;
  RowGroupLength?: number | undefined;
  DataPageSize?: number | undefined;
  ParquetVersion?: ParquetVersionValue | undefined;
  EnableStatistics?: boolean | undefined;
  IncludeOpForFullLoad?: boolean | undefined;
  CdcInsertsOnly?: boolean | undefined;
  TimestampColumnName?: string | undefined;
  ParquetTimestampInMillisecond?: boolean | undefined;
  CdcInsertsAndUpdates?: boolean | undefined;
  DatePartitionEnabled?: boolean | undefined;
  DatePartitionSequence?: DatePartitionSequenceValue | undefined;
  DatePartitionDelimiter?: DatePartitionDelimiterValue | undefined;
  UseCsvNoSupValue?: boolean | undefined;
  CsvNoSupValue?: string | undefined;
  PreserveTransactions?: boolean | undefined;
  CdcPath?: string | undefined;
  UseTaskStartTimeForFullLoadTimestamp?: boolean | undefined;
  CannedAclForObjects?: CannedAclForObjectsValue | undefined;
  AddColumnName?: boolean | undefined;
  CdcMaxBatchInterval?: number | undefined;
  CdcMinFileSize?: number | undefined;
  CsvNullValue?: string | undefined;
  IgnoreHeaderRows?: number | undefined;
  MaxFileSize?: number | undefined;
  Rfc4180?: boolean | undefined;
  DatePartitionTimezone?: string | undefined;
  AddTrailingPaddingCharacter?: boolean | undefined;
  ExpectedBucketOwner?: string | undefined;
  GlueCatalogGeneration?: boolean | undefined;
}
export interface SybaseSettings {
  DatabaseName?: string | undefined;
  Password?: string | undefined;
  Port?: number | undefined;
  ServerName?: string | undefined;
  Username?: string | undefined;
  SecretsManagerAccessRoleArn?: string | undefined;
  SecretsManagerSecretId?: string | undefined;
}
export interface TimestreamSettings {
  DatabaseName: string | undefined;
  MemoryDuration: number | undefined;
  MagneticDuration: number | undefined;
  CdcInsertsAndUpdates?: boolean | undefined;
  EnableMagneticStoreWrites?: boolean | undefined;
}
export interface CreateEndpointMessage {
  EndpointIdentifier: string | undefined;
  EndpointType: ReplicationEndpointTypeValue | undefined;
  EngineName: string | undefined;
  Username?: string | undefined;
  Password?: string | undefined;
  ServerName?: string | undefined;
  Port?: number | undefined;
  DatabaseName?: string | undefined;
  ExtraConnectionAttributes?: string | undefined;
  KmsKeyId?: string | undefined;
  Tags?: Tag[] | undefined;
  CertificateArn?: string | undefined;
  SslMode?: DmsSslModeValue | undefined;
  ServiceAccessRoleArn?: string | undefined;
  ExternalTableDefinition?: string | undefined;
  DynamoDbSettings?: DynamoDbSettings | undefined;
  S3Settings?: S3Settings | undefined;
  DmsTransferSettings?: DmsTransferSettings | undefined;
  MongoDbSettings?: MongoDbSettings | undefined;
  KinesisSettings?: KinesisSettings | undefined;
  KafkaSettings?: KafkaSettings | undefined;
  ElasticsearchSettings?: ElasticsearchSettings | undefined;
  NeptuneSettings?: NeptuneSettings | undefined;
  RedshiftSettings?: RedshiftSettings | undefined;
  PostgreSQLSettings?: PostgreSQLSettings | undefined;
  MySQLSettings?: MySQLSettings | undefined;
  OracleSettings?: OracleSettings | undefined;
  SybaseSettings?: SybaseSettings | undefined;
  MicrosoftSQLServerSettings?: MicrosoftSQLServerSettings | undefined;
  IBMDb2Settings?: IBMDb2Settings | undefined;
  ResourceIdentifier?: string | undefined;
  DocDbSettings?: DocDbSettings | undefined;
  RedisSettings?: RedisSettings | undefined;
  GcpMySQLSettings?: GcpMySQLSettings | undefined;
  TimestreamSettings?: TimestreamSettings | undefined;
}
export interface Endpoint {
  EndpointIdentifier?: string | undefined;
  EndpointType?: ReplicationEndpointTypeValue | undefined;
  EngineName?: string | undefined;
  EngineDisplayName?: string | undefined;
  Username?: string | undefined;
  ServerName?: string | undefined;
  Port?: number | undefined;
  DatabaseName?: string | undefined;
  ExtraConnectionAttributes?: string | undefined;
  Status?: string | undefined;
  KmsKeyId?: string | undefined;
  EndpointArn?: string | undefined;
  CertificateArn?: string | undefined;
  SslMode?: DmsSslModeValue | undefined;
  ServiceAccessRoleArn?: string | undefined;
  ExternalTableDefinition?: string | undefined;
  ExternalId?: string | undefined;
  DynamoDbSettings?: DynamoDbSettings | undefined;
  S3Settings?: S3Settings | undefined;
  DmsTransferSettings?: DmsTransferSettings | undefined;
  MongoDbSettings?: MongoDbSettings | undefined;
  KinesisSettings?: KinesisSettings | undefined;
  KafkaSettings?: KafkaSettings | undefined;
  ElasticsearchSettings?: ElasticsearchSettings | undefined;
  NeptuneSettings?: NeptuneSettings | undefined;
  RedshiftSettings?: RedshiftSettings | undefined;
  PostgreSQLSettings?: PostgreSQLSettings | undefined;
  MySQLSettings?: MySQLSettings | undefined;
  OracleSettings?: OracleSettings | undefined;
  SybaseSettings?: SybaseSettings | undefined;
  MicrosoftSQLServerSettings?: MicrosoftSQLServerSettings | undefined;
  IBMDb2Settings?: IBMDb2Settings | undefined;
  DocDbSettings?: DocDbSettings | undefined;
  RedisSettings?: RedisSettings | undefined;
  GcpMySQLSettings?: GcpMySQLSettings | undefined;
  TimestreamSettings?: TimestreamSettings | undefined;
}
export interface CreateEndpointResponse {
  Endpoint?: Endpoint | undefined;
}
export declare class KMSKeyNotAccessibleFault extends __BaseException {
  readonly name: "KMSKeyNotAccessibleFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<KMSKeyNotAccessibleFault, __BaseException>
  );
}
export declare class S3AccessDeniedFault extends __BaseException {
  readonly name: "S3AccessDeniedFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<S3AccessDeniedFault, __BaseException>
  );
}
export interface CreateEventSubscriptionMessage {
  SubscriptionName: string | undefined;
  SnsTopicArn: string | undefined;
  SourceType?: string | undefined;
  EventCategories?: string[] | undefined;
  SourceIds?: string[] | undefined;
  Enabled?: boolean | undefined;
  Tags?: Tag[] | undefined;
}
export interface EventSubscription {
  CustomerAwsId?: string | undefined;
  CustSubscriptionId?: string | undefined;
  SnsTopicArn?: string | undefined;
  Status?: string | undefined;
  SubscriptionCreationTime?: string | undefined;
  SourceType?: string | undefined;
  SourceIdsList?: string[] | undefined;
  EventCategoriesList?: string[] | undefined;
  Enabled?: boolean | undefined;
}
export interface CreateEventSubscriptionResponse {
  EventSubscription?: EventSubscription | undefined;
}
export declare class KMSAccessDeniedFault extends __BaseException {
  readonly name: "KMSAccessDeniedFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<KMSAccessDeniedFault, __BaseException>
  );
}
export declare class KMSDisabledFault extends __BaseException {
  readonly name: "KMSDisabledFault";
  readonly $fault: "client";
  constructor(opts: __ExceptionOptionType<KMSDisabledFault, __BaseException>);
}
export declare class KMSInvalidStateFault extends __BaseException {
  readonly name: "KMSInvalidStateFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<KMSInvalidStateFault, __BaseException>
  );
}
export declare class KMSNotFoundFault extends __BaseException {
  readonly name: "KMSNotFoundFault";
  readonly $fault: "client";
  constructor(opts: __ExceptionOptionType<KMSNotFoundFault, __BaseException>);
}
export declare class KMSThrottlingFault extends __BaseException {
  readonly name: "KMSThrottlingFault";
  readonly $fault: "client";
  constructor(opts: __ExceptionOptionType<KMSThrottlingFault, __BaseException>);
}
export declare class SNSInvalidTopicFault extends __BaseException {
  readonly name: "SNSInvalidTopicFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<SNSInvalidTopicFault, __BaseException>
  );
}
export declare class SNSNoAuthorizationFault extends __BaseException {
  readonly name: "SNSNoAuthorizationFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<SNSNoAuthorizationFault, __BaseException>
  );
}
export interface CreateFleetAdvisorCollectorRequest {
  CollectorName: string | undefined;
  Description?: string | undefined;
  ServiceAccessRoleArn: string | undefined;
  S3BucketName: string | undefined;
}
export interface CreateFleetAdvisorCollectorResponse {
  CollectorReferencedId?: string | undefined;
  CollectorName?: string | undefined;
  Description?: string | undefined;
  ServiceAccessRoleArn?: string | undefined;
  S3BucketName?: string | undefined;
}
export declare class S3ResourceNotFoundFault extends __BaseException {
  readonly name: "S3ResourceNotFoundFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<S3ResourceNotFoundFault, __BaseException>
  );
}
export interface CreateInstanceProfileMessage {
  AvailabilityZone?: string | undefined;
  KmsKeyArn?: string | undefined;
  PubliclyAccessible?: boolean | undefined;
  Tags?: Tag[] | undefined;
  NetworkType?: string | undefined;
  InstanceProfileName?: string | undefined;
  Description?: string | undefined;
  SubnetGroupIdentifier?: string | undefined;
  VpcSecurityGroups?: string[] | undefined;
}
export interface InstanceProfile {
  InstanceProfileArn?: string | undefined;
  AvailabilityZone?: string | undefined;
  KmsKeyArn?: string | undefined;
  PubliclyAccessible?: boolean | undefined;
  NetworkType?: string | undefined;
  InstanceProfileName?: string | undefined;
  Description?: string | undefined;
  InstanceProfileCreationTime?: Date | undefined;
  SubnetGroupIdentifier?: string | undefined;
  VpcSecurityGroups?: string[] | undefined;
}
export interface CreateInstanceProfileResponse {
  InstanceProfile?: InstanceProfile | undefined;
}
export interface SCApplicationAttributes {
  S3BucketPath?: string | undefined;
  S3BucketRoleArn?: string | undefined;
}
export interface DataProviderDescriptorDefinition {
  DataProviderIdentifier: string | undefined;
  SecretsManagerSecretId?: string | undefined;
  SecretsManagerAccessRoleArn?: string | undefined;
}
export interface CreateMigrationProjectMessage {
  MigrationProjectName?: string | undefined;
  SourceDataProviderDescriptors: DataProviderDescriptorDefinition[] | undefined;
  TargetDataProviderDescriptors: DataProviderDescriptorDefinition[] | undefined;
  InstanceProfileIdentifier: string | undefined;
  TransformationRules?: string | undefined;
  Description?: string | undefined;
  Tags?: Tag[] | undefined;
  SchemaConversionApplicationAttributes?: SCApplicationAttributes | undefined;
}
export interface DataProviderDescriptor {
  SecretsManagerSecretId?: string | undefined;
  SecretsManagerAccessRoleArn?: string | undefined;
  DataProviderName?: string | undefined;
  DataProviderArn?: string | undefined;
}
export interface MigrationProject {
  MigrationProjectName?: string | undefined;
  MigrationProjectArn?: string | undefined;
  MigrationProjectCreationTime?: Date | undefined;
  SourceDataProviderDescriptors?: DataProviderDescriptor[] | undefined;
  TargetDataProviderDescriptors?: DataProviderDescriptor[] | undefined;
  InstanceProfileArn?: string | undefined;
  InstanceProfileName?: string | undefined;
  TransformationRules?: string | undefined;
  Description?: string | undefined;
  SchemaConversionApplicationAttributes?: SCApplicationAttributes | undefined;
}
export interface CreateMigrationProjectResponse {
  MigrationProject?: MigrationProject | undefined;
}
export interface ComputeConfig {
  AvailabilityZone?: string | undefined;
  DnsNameServers?: string | undefined;
  KmsKeyId?: string | undefined;
  MaxCapacityUnits?: number | undefined;
  MinCapacityUnits?: number | undefined;
  MultiAZ?: boolean | undefined;
  PreferredMaintenanceWindow?: string | undefined;
  ReplicationSubnetGroupId?: string | undefined;
  VpcSecurityGroupIds?: string[] | undefined;
}
export interface CreateReplicationConfigMessage {
  ReplicationConfigIdentifier: string | undefined;
  SourceEndpointArn: string | undefined;
  TargetEndpointArn: string | undefined;
  ComputeConfig: ComputeConfig | undefined;
  ReplicationType: MigrationTypeValue | undefined;
  TableMappings: string | undefined;
  ReplicationSettings?: string | undefined;
  SupplementalSettings?: string | undefined;
  ResourceIdentifier?: string | undefined;
  Tags?: Tag[] | undefined;
}
export interface ReplicationConfig {
  ReplicationConfigIdentifier?: string | undefined;
  ReplicationConfigArn?: string | undefined;
  SourceEndpointArn?: string | undefined;
  TargetEndpointArn?: string | undefined;
  ReplicationType?: MigrationTypeValue | undefined;
  ComputeConfig?: ComputeConfig | undefined;
  ReplicationSettings?: string | undefined;
  SupplementalSettings?: string | undefined;
  TableMappings?: string | undefined;
  ReplicationConfigCreateTime?: Date | undefined;
  ReplicationConfigUpdateTime?: Date | undefined;
}
export interface CreateReplicationConfigResponse {
  ReplicationConfig?: ReplicationConfig | undefined;
}
export declare class InvalidSubnet extends __BaseException {
  readonly name: "InvalidSubnet";
  readonly $fault: "client";
  constructor(opts: __ExceptionOptionType<InvalidSubnet, __BaseException>);
}
export declare class ReplicationSubnetGroupDoesNotCoverEnoughAZs extends __BaseException {
  readonly name: "ReplicationSubnetGroupDoesNotCoverEnoughAZs";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      ReplicationSubnetGroupDoesNotCoverEnoughAZs,
      __BaseException
    >
  );
}
export interface KerberosAuthenticationSettings {
  KeyCacheSecretId?: string | undefined;
  KeyCacheSecretIamArn?: string | undefined;
  Krb5FileContents?: string | undefined;
}
export interface CreateReplicationInstanceMessage {
  ReplicationInstanceIdentifier: string | undefined;
  AllocatedStorage?: number | undefined;
  ReplicationInstanceClass: string | undefined;
  VpcSecurityGroupIds?: string[] | undefined;
  AvailabilityZone?: string | undefined;
  ReplicationSubnetGroupIdentifier?: string | undefined;
  PreferredMaintenanceWindow?: string | undefined;
  MultiAZ?: boolean | undefined;
  EngineVersion?: string | undefined;
  AutoMinorVersionUpgrade?: boolean | undefined;
  Tags?: Tag[] | undefined;
  KmsKeyId?: string | undefined;
  PubliclyAccessible?: boolean | undefined;
  DnsNameServers?: string | undefined;
  ResourceIdentifier?: string | undefined;
  NetworkType?: string | undefined;
  KerberosAuthenticationSettings?: KerberosAuthenticationSettings | undefined;
}
export interface ReplicationPendingModifiedValues {
  ReplicationInstanceClass?: string | undefined;
  AllocatedStorage?: number | undefined;
  MultiAZ?: boolean | undefined;
  EngineVersion?: string | undefined;
  NetworkType?: string | undefined;
}
export interface AvailabilityZone {
  Name?: string | undefined;
}
export interface Subnet {
  SubnetIdentifier?: string | undefined;
  SubnetAvailabilityZone?: AvailabilityZone | undefined;
  SubnetStatus?: string | undefined;
}
export interface ReplicationSubnetGroup {
  ReplicationSubnetGroupIdentifier?: string | undefined;
  ReplicationSubnetGroupDescription?: string | undefined;
  VpcId?: string | undefined;
  SubnetGroupStatus?: string | undefined;
  Subnets?: Subnet[] | undefined;
  SupportedNetworkTypes?: string[] | undefined;
}
export interface VpcSecurityGroupMembership {
  VpcSecurityGroupId?: string | undefined;
  Status?: string | undefined;
}
export interface ReplicationInstance {
  ReplicationInstanceIdentifier?: string | undefined;
  ReplicationInstanceClass?: string | undefined;
  ReplicationInstanceStatus?: string | undefined;
  AllocatedStorage?: number | undefined;
  InstanceCreateTime?: Date | undefined;
  VpcSecurityGroups?: VpcSecurityGroupMembership[] | undefined;
  AvailabilityZone?: string | undefined;
  ReplicationSubnetGroup?: ReplicationSubnetGroup | undefined;
  PreferredMaintenanceWindow?: string | undefined;
  PendingModifiedValues?: ReplicationPendingModifiedValues | undefined;
  MultiAZ?: boolean | undefined;
  EngineVersion?: string | undefined;
  AutoMinorVersionUpgrade?: boolean | undefined;
  KmsKeyId?: string | undefined;
  ReplicationInstanceArn?: string | undefined;
  ReplicationInstancePublicIpAddress?: string | undefined;
  ReplicationInstancePrivateIpAddress?: string | undefined;
  ReplicationInstancePublicIpAddresses?: string[] | undefined;
  ReplicationInstancePrivateIpAddresses?: string[] | undefined;
  ReplicationInstanceIpv6Addresses?: string[] | undefined;
  PubliclyAccessible?: boolean | undefined;
  SecondaryAvailabilityZone?: string | undefined;
  FreeUntil?: Date | undefined;
  DnsNameServers?: string | undefined;
  NetworkType?: string | undefined;
  KerberosAuthenticationSettings?: KerberosAuthenticationSettings | undefined;
}
export interface CreateReplicationInstanceResponse {
  ReplicationInstance?: ReplicationInstance | undefined;
}
export declare class InsufficientResourceCapacityFault extends __BaseException {
  readonly name: "InsufficientResourceCapacityFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      InsufficientResourceCapacityFault,
      __BaseException
    >
  );
}
export declare class StorageQuotaExceededFault extends __BaseException {
  readonly name: "StorageQuotaExceededFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<StorageQuotaExceededFault, __BaseException>
  );
}
export interface CreateReplicationSubnetGroupMessage {
  ReplicationSubnetGroupIdentifier: string | undefined;
  ReplicationSubnetGroupDescription: string | undefined;
  SubnetIds: string[] | undefined;
  Tags?: Tag[] | undefined;
}
export interface CreateReplicationSubnetGroupResponse {
  ReplicationSubnetGroup?: ReplicationSubnetGroup | undefined;
}
export interface CreateReplicationTaskMessage {
  ReplicationTaskIdentifier: string | undefined;
  SourceEndpointArn: string | undefined;
  TargetEndpointArn: string | undefined;
  ReplicationInstanceArn: string | undefined;
  MigrationType: MigrationTypeValue | undefined;
  TableMappings: string | undefined;
  ReplicationTaskSettings?: string | undefined;
  CdcStartTime?: Date | undefined;
  CdcStartPosition?: string | undefined;
  CdcStopPosition?: string | undefined;
  Tags?: Tag[] | undefined;
  TaskData?: string | undefined;
  ResourceIdentifier?: string | undefined;
}
export interface ReplicationTaskStats {
  FullLoadProgressPercent?: number | undefined;
  ElapsedTimeMillis?: number | undefined;
  TablesLoaded?: number | undefined;
  TablesLoading?: number | undefined;
  TablesQueued?: number | undefined;
  TablesErrored?: number | undefined;
  FreshStartDate?: Date | undefined;
  StartDate?: Date | undefined;
  StopDate?: Date | undefined;
  FullLoadStartDate?: Date | undefined;
  FullLoadFinishDate?: Date | undefined;
}
export interface ReplicationTask {
  ReplicationTaskIdentifier?: string | undefined;
  SourceEndpointArn?: string | undefined;
  TargetEndpointArn?: string | undefined;
  ReplicationInstanceArn?: string | undefined;
  MigrationType?: MigrationTypeValue | undefined;
  TableMappings?: string | undefined;
  ReplicationTaskSettings?: string | undefined;
  Status?: string | undefined;
  LastFailureMessage?: string | undefined;
  StopReason?: string | undefined;
  ReplicationTaskCreationDate?: Date | undefined;
  ReplicationTaskStartDate?: Date | undefined;
  CdcStartPosition?: string | undefined;
  CdcStopPosition?: string | undefined;
  RecoveryCheckpoint?: string | undefined;
  ReplicationTaskArn?: string | undefined;
  ReplicationTaskStats?: ReplicationTaskStats | undefined;
  TaskData?: string | undefined;
  TargetReplicationInstanceArn?: string | undefined;
}
export interface CreateReplicationTaskResponse {
  ReplicationTask?: ReplicationTask | undefined;
}
export interface DeleteCertificateMessage {
  CertificateArn: string | undefined;
}
export interface Certificate {
  CertificateIdentifier?: string | undefined;
  CertificateCreationDate?: Date | undefined;
  CertificatePem?: string | undefined;
  CertificateWallet?: Uint8Array | undefined;
  CertificateArn?: string | undefined;
  CertificateOwner?: string | undefined;
  ValidFromDate?: Date | undefined;
  ValidToDate?: Date | undefined;
  SigningAlgorithm?: string | undefined;
  KeyLength?: number | undefined;
}
export interface DeleteCertificateResponse {
  Certificate?: Certificate | undefined;
}
export interface DeleteConnectionMessage {
  EndpointArn: string | undefined;
  ReplicationInstanceArn: string | undefined;
}
export interface Connection {
  ReplicationInstanceArn?: string | undefined;
  EndpointArn?: string | undefined;
  Status?: string | undefined;
  LastFailureMessage?: string | undefined;
  EndpointIdentifier?: string | undefined;
  ReplicationInstanceIdentifier?: string | undefined;
}
export interface DeleteConnectionResponse {
  Connection?: Connection | undefined;
}
export interface DeleteDataMigrationMessage {
  DataMigrationIdentifier: string | undefined;
}
export interface DeleteDataMigrationResponse {
  DataMigration?: DataMigration | undefined;
}
export interface DeleteDataProviderMessage {
  DataProviderIdentifier: string | undefined;
}
export interface DeleteDataProviderResponse {
  DataProvider?: DataProvider | undefined;
}
export interface DeleteEndpointMessage {
  EndpointArn: string | undefined;
}
export interface DeleteEndpointResponse {
  Endpoint?: Endpoint | undefined;
}
export interface DeleteEventSubscriptionMessage {
  SubscriptionName: string | undefined;
}
export interface DeleteEventSubscriptionResponse {
  EventSubscription?: EventSubscription | undefined;
}
export declare class CollectorNotFoundFault extends __BaseException {
  readonly name: "CollectorNotFoundFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<CollectorNotFoundFault, __BaseException>
  );
}
export interface DeleteCollectorRequest {
  CollectorReferencedId: string | undefined;
}
export interface DeleteFleetAdvisorDatabasesRequest {
  DatabaseIds: string[] | undefined;
}
export interface DeleteFleetAdvisorDatabasesResponse {
  DatabaseIds?: string[] | undefined;
}
export interface DeleteInstanceProfileMessage {
  InstanceProfileIdentifier: string | undefined;
}
export interface DeleteInstanceProfileResponse {
  InstanceProfile?: InstanceProfile | undefined;
}
export interface DeleteMigrationProjectMessage {
  MigrationProjectIdentifier: string | undefined;
}
export interface DeleteMigrationProjectResponse {
  MigrationProject?: MigrationProject | undefined;
}
export interface DeleteReplicationConfigMessage {
  ReplicationConfigArn: string | undefined;
}
export interface DeleteReplicationConfigResponse {
  ReplicationConfig?: ReplicationConfig | undefined;
}
export interface DeleteReplicationInstanceMessage {
  ReplicationInstanceArn: string | undefined;
}
export interface DeleteReplicationInstanceResponse {
  ReplicationInstance?: ReplicationInstance | undefined;
}
export interface DeleteReplicationSubnetGroupMessage {
  ReplicationSubnetGroupIdentifier: string | undefined;
}
export interface DeleteReplicationSubnetGroupResponse {}
export interface DeleteReplicationTaskMessage {
  ReplicationTaskArn: string | undefined;
}
export interface DeleteReplicationTaskResponse {
  ReplicationTask?: ReplicationTask | undefined;
}
export interface DeleteReplicationTaskAssessmentRunMessage {
  ReplicationTaskAssessmentRunArn: string | undefined;
}
export interface DeleteReplicationTaskAssessmentRunResponse {
  ReplicationTaskAssessmentRun?: ReplicationTaskAssessmentRun | undefined;
}
export interface DescribeAccountAttributesMessage {}
export interface DescribeAccountAttributesResponse {
  AccountQuotas?: AccountQuota[] | undefined;
  UniqueAccountIdentifier?: string | undefined;
}
export interface DescribeApplicableIndividualAssessmentsMessage {
  ReplicationTaskArn?: string | undefined;
  ReplicationInstanceArn?: string | undefined;
  SourceEngineName?: string | undefined;
  TargetEngineName?: string | undefined;
  MigrationType?: MigrationTypeValue | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
}
export interface DescribeApplicableIndividualAssessmentsResponse {
  IndividualAssessmentNames?: string[] | undefined;
  Marker?: string | undefined;
}
export interface Filter {
  Name: string | undefined;
  Values: string[] | undefined;
}
export interface DescribeCertificatesMessage {
  Filters?: Filter[] | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
}
export interface DescribeCertificatesResponse {
  Marker?: string | undefined;
  Certificates?: Certificate[] | undefined;
}
export interface DescribeConnectionsMessage {
  Filters?: Filter[] | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
}
export interface DescribeConnectionsResponse {
  Marker?: string | undefined;
  Connections?: Connection[] | undefined;
}
export interface DescribeConversionConfigurationMessage {
  MigrationProjectIdentifier: string | undefined;
}
export interface DescribeConversionConfigurationResponse {
  MigrationProjectIdentifier?: string | undefined;
  ConversionConfiguration?: string | undefined;
}
export interface DescribeDataMigrationsMessage {
  Filters?: Filter[] | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
  WithoutSettings?: boolean | undefined;
  WithoutStatistics?: boolean | undefined;
}
export interface DescribeDataMigrationsResponse {
  DataMigrations?: DataMigration[] | undefined;
  Marker?: string | undefined;
}
export interface DescribeDataProvidersMessage {
  Filters?: Filter[] | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
}
export interface DescribeDataProvidersResponse {
  Marker?: string | undefined;
  DataProviders?: DataProvider[] | undefined;
}
export interface DescribeEndpointsMessage {
  Filters?: Filter[] | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
}
export interface DescribeEndpointsResponse {
  Marker?: string | undefined;
  Endpoints?: Endpoint[] | undefined;
}
export interface DescribeEndpointSettingsMessage {
  EngineName: string | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
}
export declare const EndpointSettingTypeValue: {
  readonly BOOLEAN: "boolean";
  readonly ENUM: "enum";
  readonly INTEGER: "integer";
  readonly STRING: "string";
};
export type EndpointSettingTypeValue =
  (typeof EndpointSettingTypeValue)[keyof typeof EndpointSettingTypeValue];
export interface EndpointSetting {
  Name?: string | undefined;
  Type?: EndpointSettingTypeValue | undefined;
  EnumValues?: string[] | undefined;
  Sensitive?: boolean | undefined;
  Units?: string | undefined;
  Applicability?: string | undefined;
  IntValueMin?: number | undefined;
  IntValueMax?: number | undefined;
  DefaultValue?: string | undefined;
}
export interface DescribeEndpointSettingsResponse {
  Marker?: string | undefined;
  EndpointSettings?: EndpointSetting[] | undefined;
}
export interface DescribeEndpointTypesMessage {
  Filters?: Filter[] | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
}
export interface SupportedEndpointType {
  EngineName?: string | undefined;
  SupportsCDC?: boolean | undefined;
  EndpointType?: ReplicationEndpointTypeValue | undefined;
  ReplicationInstanceEngineMinimumVersion?: string | undefined;
  EngineDisplayName?: string | undefined;
}
export interface DescribeEndpointTypesResponse {
  Marker?: string | undefined;
  SupportedEndpointTypes?: SupportedEndpointType[] | undefined;
}
export interface DescribeEngineVersionsMessage {
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
}
export declare const ReleaseStatusValues: {
  readonly BETA: "beta";
  readonly PROD: "prod";
};
export type ReleaseStatusValues =
  (typeof ReleaseStatusValues)[keyof typeof ReleaseStatusValues];
export interface EngineVersion {
  Version?: string | undefined;
  Lifecycle?: string | undefined;
  ReleaseStatus?: ReleaseStatusValues | undefined;
  LaunchDate?: Date | undefined;
  AutoUpgradeDate?: Date | undefined;
  DeprecationDate?: Date | undefined;
  ForceUpgradeDate?: Date | undefined;
  AvailableUpgrades?: string[] | undefined;
}
export interface DescribeEngineVersionsResponse {
  EngineVersions?: EngineVersion[] | undefined;
  Marker?: string | undefined;
}
export interface DescribeEventCategoriesMessage {
  SourceType?: string | undefined;
  Filters?: Filter[] | undefined;
}
export interface EventCategoryGroup {
  SourceType?: string | undefined;
  EventCategories?: string[] | undefined;
}
export interface DescribeEventCategoriesResponse {
  EventCategoryGroupList?: EventCategoryGroup[] | undefined;
}
export declare const SourceType: {
  readonly replication_instance: "replication-instance";
};
export type SourceType = (typeof SourceType)[keyof typeof SourceType];
export interface DescribeEventsMessage {
  SourceIdentifier?: string | undefined;
  SourceType?: SourceType | undefined;
  StartTime?: Date | undefined;
  EndTime?: Date | undefined;
  Duration?: number | undefined;
  EventCategories?: string[] | undefined;
  Filters?: Filter[] | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
}
export interface Event {
  SourceIdentifier?: string | undefined;
  SourceType?: SourceType | undefined;
  Message?: string | undefined;
  EventCategories?: string[] | undefined;
  Date?: Date | undefined;
}
export interface DescribeEventsResponse {
  Marker?: string | undefined;
  Events?: Event[] | undefined;
}
export interface DescribeEventSubscriptionsMessage {
  SubscriptionName?: string | undefined;
  Filters?: Filter[] | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
}
export interface DescribeEventSubscriptionsResponse {
  Marker?: string | undefined;
  EventSubscriptionsList?: EventSubscription[] | undefined;
}
export interface DescribeExtensionPackAssociationsMessage {
  MigrationProjectIdentifier: string | undefined;
  Filters?: Filter[] | undefined;
  Marker?: string | undefined;
  MaxRecords?: number | undefined;
}
export interface DefaultErrorDetails {
  Message?: string | undefined;
}
export type ErrorDetails =
  | ErrorDetails.DefaultErrorDetailsMember
  | ErrorDetails.$UnknownMember;
export declare namespace ErrorDetails {
  interface DefaultErrorDetailsMember {
    defaultErrorDetails: DefaultErrorDetails;
    $unknown?: never;
  }
  interface $UnknownMember {
    defaultErrorDetails?: never;
    $unknown: [string, any];
  }
  interface Visitor<T> {
    defaultErrorDetails: (value: DefaultErrorDetails) => T;
    _: (name: string, value: any) => T;
  }
  const visit: <T>(value: ErrorDetails, visitor: Visitor<T>) => T;
}
export interface ExportSqlDetails {
  S3ObjectKey?: string | undefined;
  ObjectURL?: string | undefined;
}
export interface SchemaConversionRequest {
  Status?: string | undefined;
  RequestIdentifier?: string | undefined;
  MigrationProjectArn?: string | undefined;
  Error?: ErrorDetails | undefined;
  ExportSqlDetails?: ExportSqlDetails | undefined;
}
export interface DescribeExtensionPackAssociationsResponse {
  Marker?: string | undefined;
  Requests?: SchemaConversionRequest[] | undefined;
}
export interface DescribeFleetAdvisorCollectorsRequest {
  Filters?: Filter[] | undefined;
  MaxRecords?: number | undefined;
  NextToken?: string | undefined;
}
export declare const CollectorStatus: {
  readonly ACTIVE: "ACTIVE";
  readonly UNREGISTERED: "UNREGISTERED";
};
export type CollectorStatus =
  (typeof CollectorStatus)[keyof typeof CollectorStatus];
export interface CollectorHealthCheck {
  CollectorStatus?: CollectorStatus | undefined;
  LocalCollectorS3Access?: boolean | undefined;
  WebCollectorS3Access?: boolean | undefined;
  WebCollectorGrantedRoleBasedAccess?: boolean | undefined;
}
export interface InventoryData {
  NumberOfDatabases?: number | undefined;
  NumberOfSchemas?: number | undefined;
}
export declare const VersionStatus: {
  readonly OUTDATED: "OUTDATED";
  readonly UNSUPPORTED: "UNSUPPORTED";
  readonly UP_TO_DATE: "UP_TO_DATE";
};
export type VersionStatus = (typeof VersionStatus)[keyof typeof VersionStatus];
export interface CollectorResponse {
  CollectorReferencedId?: string | undefined;
  CollectorName?: string | undefined;
  CollectorVersion?: string | undefined;
  VersionStatus?: VersionStatus | undefined;
  Description?: string | undefined;
  S3BucketName?: string | undefined;
  ServiceAccessRoleArn?: string | undefined;
  CollectorHealthCheck?: CollectorHealthCheck | undefined;
  LastDataReceived?: string | undefined;
  RegisteredDate?: string | undefined;
  CreatedDate?: string | undefined;
  ModifiedDate?: string | undefined;
  InventoryData?: InventoryData | undefined;
}
export interface DescribeFleetAdvisorCollectorsResponse {
  Collectors?: CollectorResponse[] | undefined;
  NextToken?: string | undefined;
}
export interface DescribeFleetAdvisorDatabasesRequest {
  Filters?: Filter[] | undefined;
  MaxRecords?: number | undefined;
  NextToken?: string | undefined;
}
export interface CollectorShortInfoResponse {
  CollectorReferencedId?: string | undefined;
  CollectorName?: string | undefined;
}
export interface ServerShortInfoResponse {
  ServerId?: string | undefined;
  IpAddress?: string | undefined;
  ServerName?: string | undefined;
}
export interface DatabaseInstanceSoftwareDetailsResponse {
  Engine?: string | undefined;
  EngineVersion?: string | undefined;
  EngineEdition?: string | undefined;
  ServicePack?: string | undefined;
  SupportLevel?: string | undefined;
  OsArchitecture?: number | undefined;
  Tooltip?: string | undefined;
}
export interface DatabaseResponse {
  DatabaseId?: string | undefined;
  DatabaseName?: string | undefined;
  IpAddress?: string | undefined;
  NumberOfSchemas?: number | undefined;
  Server?: ServerShortInfoResponse | undefined;
  SoftwareDetails?: DatabaseInstanceSoftwareDetailsResponse | undefined;
  Collectors?: CollectorShortInfoResponse[] | undefined;
}
export interface DescribeFleetAdvisorDatabasesResponse {
  Databases?: DatabaseResponse[] | undefined;
  NextToken?: string | undefined;
}
export interface DescribeFleetAdvisorLsaAnalysisRequest {
  MaxRecords?: number | undefined;
  NextToken?: string | undefined;
}
export interface FleetAdvisorLsaAnalysisResponse {
  LsaAnalysisId?: string | undefined;
  Status?: string | undefined;
}
export interface DescribeFleetAdvisorLsaAnalysisResponse {
  Analysis?: FleetAdvisorLsaAnalysisResponse[] | undefined;
  NextToken?: string | undefined;
}
export interface DescribeFleetAdvisorSchemaObjectSummaryRequest {
  Filters?: Filter[] | undefined;
  MaxRecords?: number | undefined;
  NextToken?: string | undefined;
}
export interface FleetAdvisorSchemaObjectResponse {
  SchemaId?: string | undefined;
  ObjectType?: string | undefined;
  NumberOfObjects?: number | undefined;
  CodeLineCount?: number | undefined;
  CodeSize?: number | undefined;
}
export interface DescribeFleetAdvisorSchemaObjectSummaryResponse {
  FleetAdvisorSchemaObjects?: FleetAdvisorSchemaObjectResponse[] | undefined;
  NextToken?: string | undefined;
}
export interface DescribeFleetAdvisorSchemasRequest {
  Filters?: Filter[] | undefined;
  MaxRecords?: number | undefined;
  NextToken?: string | undefined;
}
export interface DatabaseShortInfoResponse {
  DatabaseId?: string | undefined;
  DatabaseName?: string | undefined;
  DatabaseIpAddress?: string | undefined;
  DatabaseEngine?: string | undefined;
}
export interface SchemaShortInfoResponse {
  SchemaId?: string | undefined;
  SchemaName?: string | undefined;
  DatabaseId?: string | undefined;
  DatabaseName?: string | undefined;
  DatabaseIpAddress?: string | undefined;
}
export interface SchemaResponse {
  CodeLineCount?: number | undefined;
  CodeSize?: number | undefined;
  Complexity?: string | undefined;
  Server?: ServerShortInfoResponse | undefined;
  DatabaseInstance?: DatabaseShortInfoResponse | undefined;
  SchemaId?: string | undefined;
  SchemaName?: string | undefined;
  OriginalSchema?: SchemaShortInfoResponse | undefined;
  Similarity?: number | undefined;
}
export interface DescribeFleetAdvisorSchemasResponse {
  FleetAdvisorSchemas?: SchemaResponse[] | undefined;
  NextToken?: string | undefined;
}
export interface DescribeInstanceProfilesMessage {
  Filters?: Filter[] | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
}
export interface DescribeInstanceProfilesResponse {
  Marker?: string | undefined;
  InstanceProfiles?: InstanceProfile[] | undefined;
}
export interface DescribeMetadataModelAssessmentsMessage {
  MigrationProjectIdentifier: string | undefined;
  Filters?: Filter[] | undefined;
  Marker?: string | undefined;
  MaxRecords?: number | undefined;
}
export interface DescribeMetadataModelAssessmentsResponse {
  Marker?: string | undefined;
  Requests?: SchemaConversionRequest[] | undefined;
}
export interface DescribeMetadataModelConversionsMessage {
  MigrationProjectIdentifier: string | undefined;
  Filters?: Filter[] | undefined;
  Marker?: string | undefined;
  MaxRecords?: number | undefined;
}
export interface DescribeMetadataModelConversionsResponse {
  Marker?: string | undefined;
  Requests?: SchemaConversionRequest[] | undefined;
}
export interface DescribeMetadataModelExportsAsScriptMessage {
  MigrationProjectIdentifier: string | undefined;
  Filters?: Filter[] | undefined;
  Marker?: string | undefined;
  MaxRecords?: number | undefined;
}
export interface DescribeMetadataModelExportsAsScriptResponse {
  Marker?: string | undefined;
  Requests?: SchemaConversionRequest[] | undefined;
}
export interface DescribeMetadataModelExportsToTargetMessage {
  MigrationProjectIdentifier: string | undefined;
  Filters?: Filter[] | undefined;
  Marker?: string | undefined;
  MaxRecords?: number | undefined;
}
export interface DescribeMetadataModelExportsToTargetResponse {
  Marker?: string | undefined;
  Requests?: SchemaConversionRequest[] | undefined;
}
export interface DescribeMetadataModelImportsMessage {
  MigrationProjectIdentifier: string | undefined;
  Filters?: Filter[] | undefined;
  Marker?: string | undefined;
  MaxRecords?: number | undefined;
}
export interface DescribeMetadataModelImportsResponse {
  Marker?: string | undefined;
  Requests?: SchemaConversionRequest[] | undefined;
}
export interface DescribeMigrationProjectsMessage {
  Filters?: Filter[] | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
}
export interface DescribeMigrationProjectsResponse {
  Marker?: string | undefined;
  MigrationProjects?: MigrationProject[] | undefined;
}
export interface DescribeOrderableReplicationInstancesMessage {
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
}
export interface OrderableReplicationInstance {
  EngineVersion?: string | undefined;
  ReplicationInstanceClass?: string | undefined;
  StorageType?: string | undefined;
  MinAllocatedStorage?: number | undefined;
  MaxAllocatedStorage?: number | undefined;
  DefaultAllocatedStorage?: number | undefined;
  IncludedAllocatedStorage?: number | undefined;
  AvailabilityZones?: string[] | undefined;
  ReleaseStatus?: ReleaseStatusValues | undefined;
}
export interface DescribeOrderableReplicationInstancesResponse {
  OrderableReplicationInstances?: OrderableReplicationInstance[] | undefined;
  Marker?: string | undefined;
}
export interface DescribePendingMaintenanceActionsMessage {
  ReplicationInstanceArn?: string | undefined;
  Filters?: Filter[] | undefined;
  Marker?: string | undefined;
  MaxRecords?: number | undefined;
}
export interface DescribePendingMaintenanceActionsResponse {
  PendingMaintenanceActions?: ResourcePendingMaintenanceActions[] | undefined;
  Marker?: string | undefined;
}
export interface DescribeRecommendationLimitationsRequest {
  Filters?: Filter[] | undefined;
  MaxRecords?: number | undefined;
  NextToken?: string | undefined;
}
export interface Limitation {
  DatabaseId?: string | undefined;
  EngineName?: string | undefined;
  Name?: string | undefined;
  Description?: string | undefined;
  Impact?: string | undefined;
  Type?: string | undefined;
}
export interface DescribeRecommendationLimitationsResponse {
  NextToken?: string | undefined;
  Limitations?: Limitation[] | undefined;
}
export interface DescribeRecommendationsRequest {
  Filters?: Filter[] | undefined;
  MaxRecords?: number | undefined;
  NextToken?: string | undefined;
}
export interface RdsRequirements {
  EngineEdition?: string | undefined;
  InstanceVcpu?: number | undefined;
  InstanceMemory?: number | undefined;
  StorageSize?: number | undefined;
  StorageIops?: number | undefined;
  DeploymentOption?: string | undefined;
  EngineVersion?: string | undefined;
}
export interface RdsConfiguration {
  EngineEdition?: string | undefined;
  InstanceType?: string | undefined;
  InstanceVcpu?: number | undefined;
  InstanceMemory?: number | undefined;
  StorageType?: string | undefined;
  StorageSize?: number | undefined;
  StorageIops?: number | undefined;
  DeploymentOption?: string | undefined;
  EngineVersion?: string | undefined;
}
export interface RdsRecommendation {
  RequirementsToTarget?: RdsRequirements | undefined;
  TargetConfiguration?: RdsConfiguration | undefined;
}
export interface RecommendationData {
  RdsEngine?: RdsRecommendation | undefined;
}
export interface Recommendation {
  DatabaseId?: string | undefined;
  EngineName?: string | undefined;
  CreatedDate?: string | undefined;
  Status?: string | undefined;
  Preferred?: boolean | undefined;
  Settings?: RecommendationSettings | undefined;
  Data?: RecommendationData | undefined;
}
export interface DescribeRecommendationsResponse {
  NextToken?: string | undefined;
  Recommendations?: Recommendation[] | undefined;
}
export interface DescribeRefreshSchemasStatusMessage {
  EndpointArn: string | undefined;
}
export declare const RefreshSchemasStatusTypeValue: {
  readonly FAILED: "failed";
  readonly REFRESHING: "refreshing";
  readonly SUCCESSFUL: "successful";
};
export type RefreshSchemasStatusTypeValue =
  (typeof RefreshSchemasStatusTypeValue)[keyof typeof RefreshSchemasStatusTypeValue];
export interface RefreshSchemasStatus {
  EndpointArn?: string | undefined;
  ReplicationInstanceArn?: string | undefined;
  Status?: RefreshSchemasStatusTypeValue | undefined;
  LastRefreshDate?: Date | undefined;
  LastFailureMessage?: string | undefined;
}
export interface DescribeRefreshSchemasStatusResponse {
  RefreshSchemasStatus?: RefreshSchemasStatus | undefined;
}
export interface DescribeReplicationConfigsMessage {
  Filters?: Filter[] | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
}
export interface DescribeReplicationConfigsResponse {
  Marker?: string | undefined;
  ReplicationConfigs?: ReplicationConfig[] | undefined;
}
export interface DescribeReplicationInstancesMessage {
  Filters?: Filter[] | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
}
export interface DescribeReplicationInstancesResponse {
  Marker?: string | undefined;
  ReplicationInstances?: ReplicationInstance[] | undefined;
}
export interface DescribeReplicationInstanceTaskLogsMessage {
  ReplicationInstanceArn: string | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
}
export interface ReplicationInstanceTaskLog {
  ReplicationTaskName?: string | undefined;
  ReplicationTaskArn?: string | undefined;
  ReplicationInstanceTaskLogSize?: number | undefined;
}
export interface DescribeReplicationInstanceTaskLogsResponse {
  ReplicationInstanceArn?: string | undefined;
  ReplicationInstanceTaskLogs?: ReplicationInstanceTaskLog[] | undefined;
  Marker?: string | undefined;
}
export interface DescribeReplicationsMessage {
  Filters?: Filter[] | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
}
export interface ProvisionData {
  ProvisionState?: string | undefined;
  ProvisionedCapacityUnits?: number | undefined;
  DateProvisioned?: Date | undefined;
  IsNewProvisioningAvailable?: boolean | undefined;
  DateNewProvisioningDataAvailable?: Date | undefined;
  ReasonForNewProvisioningData?: string | undefined;
}
export interface ReplicationStats {
  FullLoadProgressPercent?: number | undefined;
  ElapsedTimeMillis?: number | undefined;
  TablesLoaded?: number | undefined;
  TablesLoading?: number | undefined;
  TablesQueued?: number | undefined;
  TablesErrored?: number | undefined;
  FreshStartDate?: Date | undefined;
  StartDate?: Date | undefined;
  StopDate?: Date | undefined;
  FullLoadStartDate?: Date | undefined;
  FullLoadFinishDate?: Date | undefined;
}
export interface Replication {
  ReplicationConfigIdentifier?: string | undefined;
  ReplicationConfigArn?: string | undefined;
  SourceEndpointArn?: string | undefined;
  TargetEndpointArn?: string | undefined;
  ReplicationType?: MigrationTypeValue | undefined;
  Status?: string | undefined;
  ProvisionData?: ProvisionData | undefined;
  StopReason?: string | undefined;
  FailureMessages?: string[] | undefined;
  ReplicationStats?: ReplicationStats | undefined;
  StartReplicationType?: string | undefined;
  CdcStartTime?: Date | undefined;
  CdcStartPosition?: string | undefined;
  CdcStopPosition?: string | undefined;
  RecoveryCheckpoint?: string | undefined;
  ReplicationCreateTime?: Date | undefined;
  ReplicationUpdateTime?: Date | undefined;
  ReplicationLastStopTime?: Date | undefined;
  ReplicationDeprovisionTime?: Date | undefined;
}
export interface DescribeReplicationsResponse {
  Marker?: string | undefined;
  Replications?: Replication[] | undefined;
}
export interface DescribeReplicationSubnetGroupsMessage {
  Filters?: Filter[] | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
}
export interface DescribeReplicationSubnetGroupsResponse {
  Marker?: string | undefined;
  ReplicationSubnetGroups?: ReplicationSubnetGroup[] | undefined;
}
export interface DescribeReplicationTableStatisticsMessage {
  ReplicationConfigArn: string | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
  Filters?: Filter[] | undefined;
}
export interface TableStatistics {
  SchemaName?: string | undefined;
  TableName?: string | undefined;
  Inserts?: number | undefined;
  Deletes?: number | undefined;
  Updates?: number | undefined;
  Ddls?: number | undefined;
  AppliedInserts?: number | undefined;
  AppliedDeletes?: number | undefined;
  AppliedUpdates?: number | undefined;
  AppliedDdls?: number | undefined;
  FullLoadRows?: number | undefined;
  FullLoadCondtnlChkFailedRows?: number | undefined;
  FullLoadErrorRows?: number | undefined;
  FullLoadStartTime?: Date | undefined;
  FullLoadEndTime?: Date | undefined;
  FullLoadReloaded?: boolean | undefined;
  LastUpdateTime?: Date | undefined;
  TableState?: string | undefined;
  ValidationPendingRecords?: number | undefined;
  ValidationFailedRecords?: number | undefined;
  ValidationSuspendedRecords?: number | undefined;
  ValidationState?: string | undefined;
  ValidationStateDetails?: string | undefined;
}
export interface DescribeReplicationTableStatisticsResponse {
  ReplicationConfigArn?: string | undefined;
  Marker?: string | undefined;
  ReplicationTableStatistics?: TableStatistics[] | undefined;
}
export interface DescribeReplicationTaskAssessmentResultsMessage {
  ReplicationTaskArn?: string | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
}
export interface ReplicationTaskAssessmentResult {
  ReplicationTaskIdentifier?: string | undefined;
  ReplicationTaskArn?: string | undefined;
  ReplicationTaskLastAssessmentDate?: Date | undefined;
  AssessmentStatus?: string | undefined;
  AssessmentResultsFile?: string | undefined;
  AssessmentResults?: string | undefined;
  S3ObjectUrl?: string | undefined;
}
export interface DescribeReplicationTaskAssessmentResultsResponse {
  Marker?: string | undefined;
  BucketName?: string | undefined;
  ReplicationTaskAssessmentResults?:
    | ReplicationTaskAssessmentResult[]
    | undefined;
}
export interface DescribeReplicationTaskAssessmentRunsMessage {
  Filters?: Filter[] | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
}
export interface DescribeReplicationTaskAssessmentRunsResponse {
  Marker?: string | undefined;
  ReplicationTaskAssessmentRuns?: ReplicationTaskAssessmentRun[] | undefined;
}
export interface DescribeReplicationTaskIndividualAssessmentsMessage {
  Filters?: Filter[] | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
}
export interface ReplicationTaskIndividualAssessment {
  ReplicationTaskIndividualAssessmentArn?: string | undefined;
  ReplicationTaskAssessmentRunArn?: string | undefined;
  IndividualAssessmentName?: string | undefined;
  Status?: string | undefined;
  ReplicationTaskIndividualAssessmentStartDate?: Date | undefined;
}
export interface DescribeReplicationTaskIndividualAssessmentsResponse {
  Marker?: string | undefined;
  ReplicationTaskIndividualAssessments?:
    | ReplicationTaskIndividualAssessment[]
    | undefined;
}
export declare const CreateDataMigrationMessageFilterSensitiveLog: (
  obj: CreateDataMigrationMessage
) => any;
export declare const DataMigrationSettingsFilterSensitiveLog: (
  obj: DataMigrationSettings
) => any;
export declare const DataMigrationFilterSensitiveLog: (
  obj: DataMigration
) => any;
export declare const CreateDataMigrationResponseFilterSensitiveLog: (
  obj: CreateDataMigrationResponse
) => any;
export declare const DocDbSettingsFilterSensitiveLog: (
  obj: DocDbSettings
) => any;
export declare const GcpMySQLSettingsFilterSensitiveLog: (
  obj: GcpMySQLSettings
) => any;
export declare const IBMDb2SettingsFilterSensitiveLog: (
  obj: IBMDb2Settings
) => any;
export declare const KafkaSettingsFilterSensitiveLog: (
  obj: KafkaSettings
) => any;
export declare const MicrosoftSQLServerSettingsFilterSensitiveLog: (
  obj: MicrosoftSQLServerSettings
) => any;
export declare const MongoDbSettingsFilterSensitiveLog: (
  obj: MongoDbSettings
) => any;
export declare const MySQLSettingsFilterSensitiveLog: (
  obj: MySQLSettings
) => any;
export declare const OracleSettingsFilterSensitiveLog: (
  obj: OracleSettings
) => any;
export declare const PostgreSQLSettingsFilterSensitiveLog: (
  obj: PostgreSQLSettings
) => any;
export declare const RedisSettingsFilterSensitiveLog: (
  obj: RedisSettings
) => any;
export declare const RedshiftSettingsFilterSensitiveLog: (
  obj: RedshiftSettings
) => any;
export declare const SybaseSettingsFilterSensitiveLog: (
  obj: SybaseSettings
) => any;
export declare const CreateEndpointMessageFilterSensitiveLog: (
  obj: CreateEndpointMessage
) => any;
export declare const EndpointFilterSensitiveLog: (obj: Endpoint) => any;
export declare const CreateEndpointResponseFilterSensitiveLog: (
  obj: CreateEndpointResponse
) => any;
export declare const DeleteDataMigrationResponseFilterSensitiveLog: (
  obj: DeleteDataMigrationResponse
) => any;
export declare const DeleteEndpointResponseFilterSensitiveLog: (
  obj: DeleteEndpointResponse
) => any;
export declare const DescribeDataMigrationsResponseFilterSensitiveLog: (
  obj: DescribeDataMigrationsResponse
) => any;
export declare const DescribeEndpointsResponseFilterSensitiveLog: (
  obj: DescribeEndpointsResponse
) => any;
export declare const ReplicationTaskAssessmentResultFilterSensitiveLog: (
  obj: ReplicationTaskAssessmentResult
) => any;
export declare const DescribeReplicationTaskAssessmentResultsResponseFilterSensitiveLog: (
  obj: DescribeReplicationTaskAssessmentResultsResponse
) => any;
